/*$Id: specras.c,v 5.32 2013/09/26 09:43:40 sasa Exp $*/
/*08.06.2013	19.01.2000	Белых А.И.	specras.c
Расчёт количества деталей на определенное количество 
изделий
*/
#include        <errno.h>
#include        "buhg.h"

extern double	okrg1;  /*Округление суммы*/

void		specras(int kodiz) //Код изделия
{
double		koliz;
int		i;

SQL_str         row1;
char		strsql[1024];
FILE		*ff;
char		imaf[64];
int		kolnuz=0; /*Количество наименований узлов*/
int		kolndet; /*Количество наименований деталей*/
class iceb_tu_str naim("");
int		sss;
int		kolstr1;
class iceb_tu_str ei("");
int		kodm=0;
struct  tm      *bf;
class iceb_tu_str vstr("");
time_t          vrem;
VVOD VVOD1(2);

helstr(LINES-1,0,"F10",gettext("выход"),NULL);
VVOD1.VVOD_SPISOK_add_MD(gettext("Введите количество изделий"));
     
     
if((i=vvod1(&vstr,16,&VVOD1,NULL,stdscr,-1,-1)) == FK10)
   return;
if(i == ESC)
  return;
  
koliz=vstr.ravno_atof();

if(koliz == 0)
 {
  return;
 }

GDITE();
class iceb_t_razuz_data data;
data.kod_izd=kodiz;

if((kolndet=iceb_t_razuz_kod(&data)) == 0)
 {
  sprintf(strsql,"%s %d !",gettext("Не найдено ни одной детали для изделия"),kodiz);
  iceb_t_soob(strsql);
  return;  
 }

clear();
GDITE();
SQLCURSOR cur1;
sprintf(strsql,"select naimat from Material where kodm=%d",kodiz);
if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
 {
  sprintf(strsql,"%s %d !",gettext("Не найден код материалла"),kodiz);
  iceb_t_soob(strsql);
 }  
else
 naim.new_plus(row1[0]);

printw("%s %d %s\n\
%s:%.10g\n\
---------------------------------------------------------------------\n",
gettext("Расчёт входимости в изделие"),
kodiz,naim.ravno(),
gettext("Количество изделий"),
koliz);

sprintf(imaf,"specr%d.lst",kodiz);
if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return;
 }

time(&vrem);
bf=localtime(&vrem);


short ddd=bf->tm_mday;
short mmm=bf->tm_mon+1;
short ggg=bf->tm_year+1900;

sprintf(strsql,"%s %d %s",
gettext("Расчёт входимости в изделие"),
kodiz,naim.ravno());

iceb_t_zagolov(strsql,0,0,0,0,0,0,ff);

fprintf(ff,"%s:%.10g\n",gettext("Количество изделий"),koliz);



fprintf(ff,"\
---------------------------------------------------------------------------------------------------------\n");
fprintf(ff,gettext("\
Kod |   Наименование   соcтавляющей          |Ед.из|Количество| Цена   |  Сумма   |  Остаток |  Разница |\n"));
fprintf(ff,"\
---------------------------------------------------------------------------------------------------------\n");

double koliho=0.;
double kolihr=0.;
double cena=0.;
double suma=0.;
double isuma=0.;
double ostatok=0.;

kolstr1=0;
int kolih_kod_ei=data.kod_det_ei.kolih();
for(sss=0; sss < kolih_kod_ei; sss++)
 {
  strzag(LINES-1,0,kolndet,++kolstr1);

//  kodm=kodd.ravno(sss);
  polen(data.kod_det_ei.ravno(sss),&kodm,1,'|');
  polen(data.kod_det_ei.ravno(sss),&ei,2,'|');
  cena=suma=0.;
  
  if(data.metka_mu.ravno(sss) == 0)
    sprintf(strsql,"select naimat,cenapr from Material where kodm=%d",kodm);

  if(data.metka_mu.ravno(sss) == 1)
    sprintf(strsql,"select naius,cena from Uslugi where kodus=%d",kodm);

  if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
   {
    beep();
    printw("%s-%s\n",__FUNCTION__,strsql);
    printw("%s %d !\n",gettext("Не найден код записи"),kodm);
    OSTANOV();
    naim.new_plus("");
   }  
  else
   {
    naim.new_plus(row1[0]);
    if(row1[1] != NULL)
     cena=atof(row1[1]);
    if(cena != 0.)
     cena=okrug(cena,okrg1);
   }
//  printw("sss=%d kodm=%d kolih=%f\n",sss,kodm,kold.ravno(sss));
  
  suma=koliho=kolihr=0.;
  kolihr=data.kolih_det_ei.ravno(sss)*koliz;

  suma=cena*kolihr;
  if(suma != 0.)
   suma=okrug(suma,okrg1); 
  isuma+=suma;
  ostatok=0.;
  
  if(data.metka_mu.ravno(sss) == 0)
   {
    koliho=ostdok1(ddd,mmm,ggg,0,kodm);
    ostatok=koliho-kolihr;
   }
    
  printw("%-4d %-*.*s %10.10g %8.8g %10.2f %10.10g %10.10g\n",
  kodm,
  iceb_tu_kolbait(20,naim.ravno()),iceb_tu_kolbait(20,naim.ravno()),naim.ravno(),
  kolihr,
  cena,suma,koliho,ostatok);

  fprintf(ff,"%-4d %-*s %*s %10.10g %8.8g %10.2f %10.10g %10.10g\n",
  kodm,
  iceb_tu_kolbait(40,naim.ravno()),naim.ravno(),
  iceb_tu_kolbait(5,ei.ravno()),ei.ravno(),
  kolihr,cena,suma,koliho,ostatok);
  
 }
fprintf(ff,"\
---------------------------------------------------------------------------------------------------------\n");
fprintf(ff,"%*s:%10.2f\n",iceb_tu_kolbait(71,gettext("Итого")),gettext("Итого"),isuma);
printw("%45s:%10.2f\n",iceb_tu_kolbait(45,gettext("Итого")),gettext("Итого"),isuma);

kolnuz=data.kod_uz.kolih();

if(kolnuz != 0)
 {
  printw("\n%s:\n\
----------------------------------------------------------\n",
  gettext("Входимость узлов"));
  fprintf(ff,"\n%s:\n\
-------------------------------------------------------------------------\n",
  gettext("Входимость узлов"));  
  kolstr1=0;
  for(sss=0; sss < kolnuz; sss++)
   {
    kolstr1++;
    strzag(LINES-1,0,kolndet,kolstr1);
    for(int metka=0; metka < 2; metka++)
     {
      if(metka == 0)
       sprintf(strsql,"select naimat,ei from Material where kodm=%d",data.kod_uz.ravno(sss));
      if(metka == 1)
       sprintf(strsql,"select naius,ei from Uslugi where kodus=%d",data.kod_uz.ravno(sss));
      if(sql_readkey(&bd,strsql,&row1,&cur1) != 1)
       {
        if(metka == 1)
         {        
          beep();
          printw("%s %d !\n",gettext("Не найден код записи"),data.kod_uz.ravno(sss));
          OSTANOV();
         }
        ei.new_plus("");
        naim.new_plus("");
       }  
      else
       {
        naim.new_plus(row1[0]);
        ei.new_plus(row1[1]);
        break;
       }
     }

    printw("%-4d %-*s %10.10g\n",
    data.kod_uz.ravno(sss),
    iceb_tu_kolbait(30,naim.ravno()),naim.ravno(),
    data.kolih_uz.ravno(sss)*koliz);
    
    fprintf(ff,"%-4d %-*s %*s %10.10g\n",
    data.kod_uz.ravno(sss),
    iceb_tu_kolbait(40,naim.ravno()),naim.ravno(),
    iceb_tu_kolbait(5,ei.ravno()),ei.ravno(),
    data.kolih_uz.ravno(sss)*koliz);
    
   }

 }

podpis(ff);
fclose(ff);

OSTANOV();

class spis_oth oth;
oth.spis_imaf.plus(imaf);
oth.spis_naim.plus(gettext("Спецификация на изделие"));

iceb_t_ustpeh(imaf,3);

iceb_t_rabfil(&oth,"");

}
