/*$Id: zarbesv.c,v 5.17 2014/02/28 05:13:48 sasa Exp $*/
/*26.02.2014	25.01.2011	Белых А.И.	zarbesv.c
Расчёт баз удержания единого социального взноса
*/
#include <errno.h>
#include "buhg.h"

int zarbesv_stn(short mr,short gr,const char *imaf,class masiv_din_int *spis_tabnom,class masiv_din_double *suma_nah,double max_sum_for_soc);

int zarbesv_r(int metka_r,
short mr,short gr,
double itogo_nah,
double itogo_suma_nvr,
double suma_prev,
double itogo_suma,
double itogo_suma_p,
double suma_esv_ob,
double itogo_suma_inv,
double itogo_suma_inv_p,
double suma_esv_inv,
double itogo_suma_dog,
double itogo_suma_dog_p,
double suma_esv_dog,
double itogo_suma_bol,
double suma_esv_bol,
double itogo_suma_bol_inv,
double suma_esv_bol_inv,
double prog_min_tek,
const char *imaf);

extern short	mmm,ggg;
extern char *shetb; /*Бюджетные счета начислений*/
extern char *shetbu; /*Бюджетные счета удержаний*/
extern short *kodbl;  /*Код начисления больничного*/
extern class iceb_tu_str kod_dop_nah_bol; /*коды начилений дополнительно входящие в расчёт удержания ЕСВ с больничного*/
extern int kod_esv;
extern int kod_esv_bol;
extern int kod_esv_bol_inv;
extern int kod_esv_inv;
extern int kod_esv_dog;

extern class iceb_tu_str knvr_esv_r; /*Коды не входящие в расчёт единого социального взноса с работника*/

int zarbesv(class spis_oth *oth)
{
static class iceb_tu_str dat1("");
int		kom1;
char		imaf[64],imaf_hoz[64],imaf_bud[64];
char		strsql[512];
short		mr,gr;
if(dat1.ravno()[0] == '\0')
 {
  sprintf(strsql,"%d.%d",mmm,ggg);
  dat1.new_plus(strsql);
 }
VVOD VVOD1(2);
VVOD1.VVOD_SPISOK_add_ZAG(gettext("Расчёт баз налогообложения для удержания единого социального взноса"));
VVOD1.VVOD_SPISOK_add_MD(gettext("Введите дату (м.г)."));
 
naz:;

clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"Enter",gettext("расчитать"),
"F10",gettext("выход"),NULL);

kom1=vvod1(&dat1,8,&VVOD1,NULL,stdscr,-1,-1);

switch(kom1)
 {
  case FK1:
   GDITE();
//   iceb_t_pdoc("zarp4_7_8.txt");
   goto naz;
  
  case FK10:
  case ESC:
   return(1);

  case FK2:
  case ENTER:
   break;

  default:
    goto naz;   
 }

if(rsdat1(&mr,&gr,dat1.ravno()) != 0)
 {
  iceb_t_soob(gettext("Не верно введена дата !"));
  goto naz;
 }

GDITE();
double itogo_nah[2]={0.,0.}; /*общая сумма всех начилений*/
double itogo_suma_nvr[2]={0.,0.}; /*сумма не вошедшая в расчёт*/
double itogo_suma[2]={0.,0.};
double itogo_suma_bol[2]={0.,0.};
double itogo_suma_bol_inv[2]={0.,0.};
double itogo_suma_inv[2]={0.,0.};
double itogo_suma_dog[2]={0.,0.};

double itogo_suma_p[2]={0.,0.}; /*Cумма превышения*/
double itogo_suma_inv_p[2]={0.,0.};
double itogo_suma_dog_p[2]={0.,0.};

double suma_esv_ob[2]={0.,0.};
double suma_esv_bol[2]={0.,0.};
double suma_esv_bol_inv[2]={0.,0.};
double suma_esv_inv[2]={0.,0.};
double suma_esv_dog[2]={0.,0.};
double suma_zap=0.;
double suma_tab[2]={0.,0.};
double suma_prev[2]={0.,0.};
int metka_inv=0;
int metka_dog=0;
int kod_zap=0;

class zar_read_tn1h nastr;
zar_read_tn1(1,mr,gr,&nastr);

int kolstr=0,kolstr1=0,kolstr2=0;
SQL_str row,row1;
class SQLCURSOR cur,cur1;
sprintf(strsql,"select tabn,lgot from Zarn where god=%d and mes=%d",gr,mr);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
if(kolstr == 0)
 {
  iceb_t_soob(gettext("Не найдено ни одной записи !"));
  return(1);
 }
char imaf_lgot[64];
sprintf(imaf_lgot,"sl%d.lst",getpid());
class iceb_fopen ff_lgot;

if(ff_lgot.start(imaf_lgot,"w") != 0)
 return(1);

iceb_t_zagolov(gettext("Список работников для которых применялась социальная льгота"),0,mr,gr,0,0,0,ff_lgot.ff);
fprintf(ff_lgot.ff,"%s %d.%d %s\n",gettext("Дата"),mr,gr,gettext("г."));
fprintf(ff_lgot.ff,"\
------------------------------------------------------------------\n");
fprintf(ff_lgot.ff,gettext("\
Таб.н.|                              |Код льготы|Сумма начиленная|\n"));
/**
123456 123456789012345678901234567890 1234567890 1234567890123456
***/
fprintf(ff_lgot.ff,"\
------------------------------------------------------------------\n");

class masiv_din_int spis_tabnom; /*список табельных номеров имеющих превышение зарплаты над максимальной суммой налогообложения*/
class masiv_din_double suma_nah; /*Сумма начисленная по табельным номерам*/

/*Чтение настроек для расчёта единого социального взноса*/
zarrnesv();


while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);

  sprintf(strsql,"select prn,knah,suma,shet,godn,mesn from Zarp \
where tabn=%s and datz >= '%04d-%d-01' and datz <= '%04d-%d-31' \
and suma <> 0.",row[0],gr,mr,gr,mr);

  if((kolstr2=cur1.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    continue;
   }

  if(kolstr2 == 0)
   continue;
  
  memset(suma_tab,'\0',sizeof(suma_tab));
  memset(suma_prev,'\0',sizeof(suma_prev));
  metka_inv=metka_dog=0;  
  metka_inv=zarprtn(mr,gr,atoi(row[0]),2);
  metka_dog=zarprtn(mr,gr,atoi(row[0]),3);
  while(cur1.read_cursor(&row1) != 0)
   {
    kod_zap=atoi(row1[1]);
    suma_zap=atof(row1[2]);    

    if(atoi(row1[0]) == 1) /*Начисления*/
     {
      itogo_nah[0]+=suma_zap;
      if(proverka(shetb,row1[3],0,0) == 0)
        itogo_nah[1]+=suma_zap;
       
      if(proverka(knvr_esv_r.ravno(),row1[1],0,1) == 0)
       {
        itogo_suma_nvr[0]+=suma_zap;
        if(proverka(shetb,row1[3],0,0) == 0)
          itogo_suma_nvr[1]+=suma_zap;
        continue;
       }
  
      suma_tab[0]+=suma_zap;
      if(proverka(shetb,row1[3],0,0) == 0)
        suma_tab[1]+=suma_zap;

      if(provkod(kodbl,kod_zap) >= 0 || proverka(kod_dop_nah_bol.ravno(),kod_zap,0,1) == 0)
       {
        if(metka_inv == 1)
         itogo_suma_bol_inv[0]+=suma_zap;
        else         
         itogo_suma_bol[0]+=suma_zap;
        if(proverka(shetb,row1[3],0,0) == 0)
         {
          itogo_suma_bol[1]+=suma_zap;
          if(metka_inv == 1)
           itogo_suma_bol_inv[1]+=suma_zap;
         }
        continue;
       }              

     if(metka_inv == 1)
      {
       itogo_suma_inv[0]+=suma_zap;
       if(proverka(shetb,row1[3],0,0) == 0)
         itogo_suma_inv[1]+=suma_zap;
       continue;
      }

     if(metka_dog == 1)
      {
       itogo_suma_dog[0]+=suma_zap;
       if(proverka(shetb,row1[3],0,0) == 0)
         itogo_suma_dog[1]+=suma_zap;
       continue;
      }

     itogo_suma[0]+=suma_zap;
     if(proverka(shetb,row1[3],0,0) == 0)
       itogo_suma[1]+=suma_zap;

     }
    else /*удержания*/
     {
      if(kod_zap == kod_esv)
       suma_esv_ob[0]+=suma_zap;

      if(kod_zap == kod_esv_bol)
       suma_esv_bol[0]+=suma_zap;
      if(kod_zap == kod_esv_bol_inv)
       suma_esv_bol_inv[0]+=suma_zap;

      if(kod_zap == kod_esv_inv)
       suma_esv_inv[0]+=suma_zap;

      if(kod_zap == kod_esv_dog)
       suma_esv_dog[0]+=suma_zap;

      if(proverka(shetbu,row1[3],0,0) == 0)
       {
        if(kod_zap == kod_esv)
         suma_esv_ob[1]+=suma_zap;

        if(kod_zap == kod_esv_bol)
         suma_esv_bol[1]+=suma_zap;
        if(kod_zap == kod_esv_bol_inv)
         suma_esv_bol_inv[1]+=suma_zap;

        if(kod_zap == kod_esv_inv)
         suma_esv_inv[1]+=suma_zap;

        if(kod_zap == kod_esv_dog)
         suma_esv_dog[1]+=suma_zap;

       }
     }
     
   }

  if(suma_tab[0] > nastr.max_sum_for_soc)
   {
    suma_prev[0]+=suma_tab[0]-nastr.max_sum_for_soc;
    if(metka_inv == 1)
     itogo_suma_inv_p[0]+=suma_tab[0]-nastr.max_sum_for_soc;
    if(metka_dog == 1)
     itogo_suma_dog_p[0]+=suma_tab[0]-nastr.max_sum_for_soc;
    if(metka_dog == 0 && metka_inv == 0)
     itogo_suma_p[0]+=suma_tab[0]-nastr.max_sum_for_soc;

    spis_tabnom.plus(atoi(row[0]));
    suma_nah.plus(suma_tab[0]);
   }

  if(suma_tab[1] > nastr.max_sum_for_soc)
   {
    suma_prev[1]+=suma_tab[1]-nastr.max_sum_for_soc;
    if(metka_inv == 1)
     itogo_suma_inv_p[1]+=suma_tab[1]-nastr.max_sum_for_soc;
    if(metka_dog == 1)
     itogo_suma_dog_p[1]+=suma_tab[1]-nastr.max_sum_for_soc;
    if(metka_dog == 0 && metka_inv == 0)
     itogo_suma_p[1]+=suma_tab[1]-nastr.max_sum_for_soc;
   }

  if(row[1][0] != '\0')
   {
    class iceb_tu_str famil(zargetfio(row[0]));
    
    fprintf(ff_lgot.ff,"%6s|%-*.*s|%-*.*s|%16.2f|\n",
    row[0],
    iceb_tu_kolbait(30,famil.ravno()),
    iceb_tu_kolbait(30,famil.ravno()),
    famil.ravno(),
    iceb_tu_kolbait(10,row[1]),
    iceb_tu_kolbait(10,row[1]),
    row[1],
    suma_tab[0]);    
   }
  
 }

fprintf(ff_lgot.ff,"\
------------------------------------------------------------------\n");
ff_lgot.end();

/*Общая сумма*/
sprintf(imaf,"esv%d.lst",getpid());

zarbesv_r(0,mr,gr,itogo_nah[0],itogo_suma_nvr[0],suma_prev[0],
itogo_suma[0],itogo_suma_p[0],suma_esv_ob[0],
itogo_suma_inv[0],itogo_suma_inv_p[0],suma_esv_inv[0],
itogo_suma_dog[0],itogo_suma_dog_p[0],suma_esv_dog[0],
itogo_suma_bol[0],suma_esv_bol[0],itogo_suma_bol_inv[0],suma_esv_bol_inv[0],nastr.max_sum_for_soc,imaf);

if(shetb != NULL)
 {

  sprintf(imaf_hoz,"hesv%d.lst",getpid());
  zarbesv_r(1,mr,gr,itogo_nah[0]-itogo_nah[1],itogo_suma_nvr[0]-itogo_suma_nvr[1],suma_prev[0]-suma_prev[1],
  itogo_suma[0]-itogo_suma[1],itogo_suma_p[0]-itogo_suma_p[1],suma_esv_ob[0]-suma_esv_ob[1],
  itogo_suma_inv[0]-itogo_suma_inv[1],itogo_suma_inv_p[0]-itogo_suma_inv_p[1],suma_esv_inv[0]-suma_esv_inv[1],
  itogo_suma_dog[0]-itogo_suma_dog[1],itogo_suma_dog_p[0]-itogo_suma_dog_p[1],suma_esv_dog[0]-suma_esv_dog[1],
  itogo_suma_bol[0]-itogo_suma_bol[1],suma_esv_bol[0]-suma_esv_bol[1],
  itogo_suma_bol_inv[0]-itogo_suma_bol_inv[1],suma_esv_bol_inv[0]-suma_esv_bol_inv[1],
  nastr.max_sum_for_soc,imaf_hoz);

  sprintf(imaf_bud,"besv%d.lst",getpid());
  zarbesv_r(2,mr,gr,itogo_nah[1],itogo_suma_nvr[1],suma_prev[1],
  itogo_suma[1],itogo_suma_p[1],suma_esv_ob[1],
  itogo_suma_inv[1],itogo_suma_inv_p[1],suma_esv_inv[1],
  itogo_suma_dog[1],itogo_suma_dog_p[1],suma_esv_dog[1],
  itogo_suma_bol[1],suma_esv_bol[1],
  itogo_suma_bol_inv[1],suma_esv_bol_inv[1],
  nastr.max_sum_for_soc,imaf_bud);
 }

char imaf_st[64];
sprintf(imaf_st,"spist%d.lst",getpid());



if(zarbesv_stn(mr,gr,imaf_st,&spis_tabnom,&suma_nah, nastr.max_sum_for_soc) != 0)
  memset(imaf_st,'\0',sizeof(imaf_st)); 




oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Расчёт баз налогообложения для удержания единого социального взноса"));

oth->spis_imaf.plus(imaf_lgot);
oth->spis_naim.plus(gettext("Список работников для которых применялась социальная льгота"));

if(imaf_st[0] != '\0')
 {
  oth->spis_imaf.plus(imaf_st);
  oth->spis_naim.plus(gettext("Список работников с превышением суммы"));
 }

if(shetb != NULL)
 {
  oth->spis_imaf.plus(imaf_hoz);
  sprintf(strsql,"%s %s",gettext("Расчёт баз налогообложения для удержания единого социального взноса"),gettext("Хозрасчёт"));
  oth->spis_naim.plus(strsql);

  oth->spis_imaf.plus(imaf_bud);
  sprintf(strsql,"%s %s",gettext("Расчёт баз налогообложения для удержания единого социального взноса"),gettext("Бюджет"));
  oth->spis_naim.plus(strsql);
 }

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),3);

return(0);
}


/***********************************/
/*Распечатка*/
/**************************/
int zarbesv_r(int metka_r,
short mr,short gr,
double itogo_nah,
double itogo_suma_nvr,
double suma_prev,
double itogo_suma,
double itogo_suma_p,
double suma_esv_ob,
double itogo_suma_inv,
double itogo_suma_inv_p,
double suma_esv_inv,
double itogo_suma_dog,
double itogo_suma_dog_p,
double suma_esv_dog,
double itogo_suma_bol,
double suma_esv_bol,
double itogo_suma_bol_inv,
double suma_esv_bol_inv,
double max_sum_for_soc,
const char *imaf)
{
char strsql[1024];
FILE *ff;

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }



if(metka_r == 0)
  iceb_t_zagolov(gettext("Расчёт баз налогообложения для удержания единого социального взноса"),0,mr,gr,0,0,0,ff);

if(metka_r == 1)
 {
  sprintf(strsql,"%s %s",gettext("Расчёт баз налогообложения для удержания единого социального взноса"),gettext("Хозрасчёт"));
  iceb_t_zagolov(strsql,0,mr,gr,0,0,0,ff);
 }
if(metka_r == 2)
 {
  sprintf(strsql,"%s %s",gettext("Расчёт баз налогообложения для удержания единого социального взноса"),gettext("Бюджет"));
  iceb_t_zagolov(strsql,0,mr,gr,0,0,0,ff);
 }
fprintf(ff,"%s %d.%d %s\n",gettext("Дата"),mr,gr,gettext("г."));

fprintf(ff,"\
%s:%d\n\
%s:%d\n\
%s:%d\n\
%s:%d\n\
%s:%d\n\
%s:%s\n",
gettext("Код удержания единого социального взноса"),kod_esv,
gettext("Код удержания единого социального взноса для больничных"),kod_esv_bol,
gettext("Код удержания единого социального взноса c больничных для ивнвалидов"),kod_esv_bol_inv,
gettext("Код удержания единого социального взноса для инвалидов"),kod_esv_inv,
gettext("Код удержания единого социального взноса для договоров"),kod_esv_dog,
gettext("Коды начислений не входящие в расчёт удержания единого социального взноса"),knvr_esv_r.ravno());

sprintf(strsql,"%s %.2f",gettext("Cумма больще"),max_sum_for_soc);

fprintf(ff,"\n\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n",
iceb_tu_kolbait(30,gettext("Начислено")),gettext("Начислено"),itogo_nah,
iceb_tu_kolbait(30,gettext("Не вошло в расчёт")),gettext("Не вошло в расчёт"),itogo_suma_nvr,
iceb_tu_kolbait(30,strsql),strsql,suma_prev,
iceb_tu_kolbait(30,gettext("Сумма взятая в расчёт")),gettext("Сумма взятая в расчёт"),itogo_nah-itogo_suma_nvr-suma_prev);

class zarrnesvp_rek esvp;

zarrnesvp(mr,gr,&esvp);
 
fprintf(ff,"\n%s %.2f%%\n\
----------------------------------------------------------------\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n",
gettext("Единый социальный взнос"),esvp.proc_esv,
iceb_tu_kolbait(30,gettext("Начислено")),gettext("Начислено"),itogo_suma,
iceb_tu_kolbait(30,gettext("Сумма превышения")),gettext("Сумма превышения"),itogo_suma_p,
iceb_tu_kolbait(30,gettext("Взято в расчёт")),gettext("Взято в расчёт"),itogo_suma-itogo_suma_p,
iceb_tu_kolbait(30,gettext("Сумма удержания")),gettext("Сумма удержания"),suma_esv_ob);

fprintf(ff,"\n%s %.2f%%\n\
----------------------------------------------------------------\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n",
gettext("Единый социальный взнос c инвалидов"),esvp.proc_esv_inv,
iceb_tu_kolbait(30,gettext("Начислено")),gettext("Начислено"),itogo_suma_inv,
iceb_tu_kolbait(30,gettext("Сумма превышения")),gettext("Сумма превышения"),itogo_suma_inv_p,
iceb_tu_kolbait(30,gettext("Взято в расчёт")),gettext("Взято в расчёт"),itogo_suma_inv-itogo_suma_inv_p,
iceb_tu_kolbait(30,gettext("Сумма удержания")),gettext("Сумма удержания"),suma_esv_inv);

fprintf(ff,"\n%s %.2f%%\n\
----------------------------------------------------------------\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n\
%*s:%10.2f\n",
gettext("Единый социальный взнос c работающих по договорам"),esvp.proc_esv_dog,
iceb_tu_kolbait(30,gettext("Начислено")),gettext("Начислено"),itogo_suma_dog,
iceb_tu_kolbait(30,gettext("Сумма превышения")),gettext("Сумма превышения"),itogo_suma_dog_p,
iceb_tu_kolbait(30,gettext("Взято в расчёт")),gettext("Взято в расчёт"),itogo_suma_dog-itogo_suma_dog_p,
iceb_tu_kolbait(30,gettext("Сумма удержания")),gettext("Сумма удержания"),suma_esv_dog);

fprintf(ff,"\n%s %.2f%%\n\
----------------------------------------------------------------\n\
%*s:%10.2f\n\
%*s:%10.2f\n",
gettext("Единый социальный взнос c больничных"),esvp.proc_esv_bol,
iceb_tu_kolbait(30,gettext("Начислено")),gettext("Начислено"),itogo_suma_bol,
iceb_tu_kolbait(30,gettext("Сумма удержания")),gettext("Сумма удержания"),suma_esv_bol);

fprintf(ff,"\n%s %.2f%%\n\
----------------------------------------------------------------\n\
%*s:%10.2f\n\
%*s:%10.2f\n",
gettext("Единый социальный взнос c больничных для инвалидов"),esvp.proc_esv_bol_inv,
iceb_tu_kolbait(30,gettext("Начислено")),gettext("Начислено"),itogo_suma_bol_inv,
iceb_tu_kolbait(30,gettext("Сумма удержания")),gettext("Сумма удержания"),suma_esv_bol_inv);


podpis(ff);
fclose(ff);
return(0);
}
/************************************/
/*Распечатка табельных номеров имеющих превышение*/
/***********************************/

int zarbesv_stn(short mr,short gr,const char *imaf,class masiv_din_int *spis_tabnom,class masiv_din_double *suma_nah,double max_sum_for_soc)
{
SQL_str row;
class SQLCURSOR cur;
char strsql[1024];
class iceb_tu_str fio("");
double itogo_nah=0.;
double itogo_prev=0.;

int kolih=spis_tabnom->kolih();

if(kolih == 0)
 return(1);
 
FILE *ff;
if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

iceb_t_zagolov(gettext("Список работников с превышением максимальной суммы для расчёта единого соц. отчисления"),0,0,0,0,mr,gr,ff);
fprintf(ff,"%s %d.%d %s\n",gettext("Дата"),mr,gr,gettext("г."));

fprintf(ff,"%s:%.2f\n",gettext("Максимальная сумма"),max_sum_for_soc);
fprintf(ff,"\
----------------------------------------------------------------------\n");
fprintf(ff,gettext("\
Таб.н.|          Фамилия,имя,отчество          |Начислено |Превышение|\n"));
fprintf(ff,"\
----------------------------------------------------------------------\n");
double suma_n=0;
double suma_p=0;
for(int nom=0; nom < kolih; nom++)
 {
  fio.new_plus("");
  
  sprintf(strsql,"select fio from Kartb where tabn=%d",spis_tabnom->ravno(nom));
  
  if(readkey(strsql,&row,&cur) == 1)
   fio.new_plus(row[0]);
  
  suma_n=suma_nah->ravno(nom);
  suma_p=suma_n-max_sum_for_soc;

  itogo_nah+=suma_n;
  itogo_prev+=suma_p;
  
  fprintf(ff,"%6d %-*.*s %10.2f %10.2f\n",
  spis_tabnom->ravno(nom),
  iceb_tu_kolbait(40,fio.ravno()),
  iceb_tu_kolbait(40,fio.ravno()),
  fio.ravno(),
  suma_n,
  suma_p);
  


 }
fprintf(ff,"\
----------------------------------------------------------------------\n");
fprintf(ff,"%*s %10.2f %10.2f\n",
iceb_tu_kolbait(47,gettext("Итого")),
gettext("Итого"),
itogo_nah,
itogo_prev);



podpis(ff);
fclose(ff);

return(0);
}