/*$Id: zarsocd.c,v 5.80 2013/09/26 09:43:46 sasa Exp $*/
/*28.09.2014	16.03.2002	Белых А.И.	zarsocd.c
Расчёт отчислений в пенсионный фонд и фонд соцстраха по диапазонам
*/
#include        <errno.h>
#include        "buhg.h"

extern short	metkarnb; //0-расчёт налогов для бюджета пропорциональный 1-последовательный
extern short    *kodbl;  /*Код начисления больничного*/
extern short    *kuvvr_pens_sfz; //Коды удержаний входящие в расчёт при отчислении с фонда зарплаты
extern short    *knnf; //Коды начислений недежными формами 

extern char	*shetb; /*Бюджетные счета*/
extern char	*shetbu; /*Бюджетные счета удержаний*/
extern short    *kodmp;   /*Коды материальной помощи*/
extern short	mmm,ggg;

int zarsocd(class spis_oth *oth)
{
int kodbzr=0;  /*Код отчисления на безработицу*/
int kodsocstr=0;  /*Код отчисления на соц-страх*/
time_t 		tmm;
static class iceb_tu_str dat1("");
int		kom1;
FILE		*ff;
char		imaf[64];
char		strsql[512];
short		mr,gr;

if(dat1.ravno()[0] == '\0')
 {
  sprintf(strsql,"%d.%d",mmm,ggg);
  dat1.new_plus(strsql);
 }
VVOD VVOD1(2);
VVOD1.VVOD_SPISOK_add_ZAG(gettext("Расчёт баз налогообложения для соц. отчислений"));
VVOD1.VVOD_SPISOK_add_MD(gettext("Введите дату (м.г)."));
 
naz:;

clear();

helstr(LINES-1,0,"F1",gettext("помощь"),
"Enter",gettext("расчитать"),
"F10",gettext("выход"),NULL);

kom1=vvod1(&dat1,8,&VVOD1,NULL,stdscr,-1,-1);

switch(kom1)
 {
  case FK1:
   GDITE();
   iceb_t_pdoc("zarp4_7_8.txt");
   goto naz;
  
  case FK10:
  case ESC:
   return(1);

  case FK2:
  case ENTER:
   break;

  default:
    goto naz;   
 }

if(rsdat1(&mr,&gr,dat1.ravno()) != 0)
 {
  iceb_t_soob(gettext("Не верно введена дата !"));
  goto naz;
 }

GDITE();
iceb_t_poldan("Код фонда социального страхования",&kodsocstr,"zarnast.alx");
iceb_t_poldan("Код отчисления на безработицу",&kodbzr,"zarnast.alx");

time(&tmm);

clear();
printw("%s\n",gettext("Расчёт баз налогообложения для соц. отчислений"));
printw("%s:%d.%d%s\n",
gettext("Дата"),mr,gr,gettext("г."));

//Читаем настройки
//zar_read_tn(1,mr,gr,NULL);
 
SQLCURSOR cur;
SQLCURSOR cur1;
SQLCURSOR curr;
int	kolstr=0,kolstr1=0,kolstr2=0;
SQL_str		row,row1;

sprintf(strsql,"select tabn from Zarn where god=%d and mes=%d",gr,mr);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
if(kolstr == 0)
 {
  iceb_t_soob(gettext("Не найдено ни одной записи !"));
  return(1);
 }

double    sumanah[2]; //Общая сумма которая начислена/бюджет
memset(sumanah,'\0',sizeof(sumanah));
double    sumanahtab[2]; //Общая сумма которая начислена/бюджет
memset(sumanahtab,'\0',sizeof(sumanahtab));

double    pensnvr[2]; //Пенсионные не вошедшие в расчёт
double    pensnvrtab[2]; //Пенсионные не вошедшие в расчёт
memset(pensnvr,'\0',sizeof(pensnvr));
memset(pensnvrtab,'\0',sizeof(pensnvrtab));

double    socnvr[2]; //Соцстрах не вошедший в расчёт
double    socnvrtab[2]; //Соцстрах не вошедший в расчёт
memset(socnvr,'\0',sizeof(socnvr));
memset(socnvrtab,'\0',sizeof(socnvrtab));

double    bezrnvr[2]; //Безработица не вошедшая в расчёт
double    bezrnvrtab[2]; //Безработица не вошедшая в расчёт
memset(bezrnvr,'\0',sizeof(bezrnvr));
memset(bezrnvrtab,'\0',sizeof(bezrnvrtab));

double    sumaprevm[2];  //Сумма превышающая максимум с которой берется налог
double    sumaprevmsoc[2];  //Сумма превышающая максимум с которой берется налог
double    sumaprevmbez[2];  //Сумма превышающая максимум с которой берется налог
memset(sumaprevm,'\0',sizeof(sumaprevm));
memset(sumaprevmsoc,'\0',sizeof(sumaprevmsoc));
memset(sumaprevmbez,'\0',sizeof(sumaprevmbez));

double	  sumvrpens1[2];
memset(sumvrpens1,'\0',sizeof(sumvrpens1));
double	  sumvrpens2[2];
memset(sumvrpens2,'\0',sizeof(sumvrpens2));

short	  mespp,godpp;

double	  sumapnal[2];
memset(sumapnal,'\0',sizeof(sumapnal));
double	  sumapnaltab[2];
memset(sumapnaltab,'\0',sizeof(sumapnaltab));

double	  sumapnal1[2];
memset(sumapnal1,'\0',sizeof(sumapnal1));
double	  sumapnal2[2];
memset(sumapnal2,'\0',sizeof(sumapnal2));

double	  sumvrsoc1[2];
memset(sumvrsoc1,'\0',sizeof(sumvrsoc1));
double	  sumvrsoc2[2];
memset(sumvrsoc2,'\0',sizeof(sumvrsoc2));

double	  sumvrbez1=0.;
double	  sumvrbez2=0.;

double	  sumasnal[2];
memset(sumasnal,'\0',sizeof(sumasnal));
double	  sumasnaltab[2];
memset(sumasnaltab,'\0',sizeof(sumasnaltab));

double	  sumabnal[2];
memset(sumabnal,'\0',sizeof(sumabnal));
double	  sumabnaltab[2];
memset(sumabnaltab,'\0',sizeof(sumabnaltab));

double	  sumasnal1[2];
memset(sumasnal1,'\0',sizeof(sumasnal1));
double	  sumasnal2[2];
memset(sumasnal2,'\0',sizeof(sumasnal2));

double	  sumanvbezr[2]; //Сумма не вошедшая в расчёт безработицы (пенсионеры и инвалиды)
memset(sumanvbezr,'\0',sizeof(sumanvbezr));

double    sumaogr[2];
memset(sumaogr,'\0',sizeof(sumaogr));

//*****************************
double suma_ndfnz_pens[2]; //неденежные формы начисления зарплаты
memset(&suma_ndfnz_pens,'\0',sizeof(suma_ndfnz_pens));

double suma_ndfnz_pens_tab[2]; //неденежные формы начисления зарплаты
memset(&suma_ndfnz_pens_tab,'\0',sizeof(suma_ndfnz_pens_tab));

double suma_ufn_pens_tab[2]; //сумма на которую увеличился фонд облагаемый изза неденежных форм начисления зарплаты
memset(&suma_ufn_pens_tab,'\0',sizeof(suma_ufn_pens_tab));
double suma_ufn_pens[2]; //сумма на которую увеличился фонд облагаемый изза неденежных форм начисления зарплаты
memset(&suma_ufn_pens,'\0',sizeof(suma_ufn_pens));


//*****************************
double suma_ndfnz_socstr[2]; //неденежные формы начисления зарплаты
memset(&suma_ndfnz_socstr,'\0',sizeof(suma_ndfnz_socstr));

double suma_ndfnz_socstr_tab[2]; //неденежные формы начисления зарплаты
memset(&suma_ndfnz_socstr_tab,'\0',sizeof(suma_ndfnz_socstr_tab));

double suma_ufn_socstr_tab[2]; //сумма на которую увеличился фонд облагаемый изза неденежных форм начисления зарплаты
memset(&suma_ufn_socstr_tab,'\0',sizeof(suma_ufn_socstr_tab));
double suma_ufn_socstr[2]; //сумма на которую увеличился фонд облагаемый изза неденежных форм начисления зарплаты
memset(&suma_ufn_socstr,'\0',sizeof(suma_ufn_socstr));


//*****************************
double suma_ndfnz_bezr[2]; //неденежные формы начисления зарплаты
memset(&suma_ndfnz_bezr,'\0',sizeof(suma_ndfnz_bezr));

double suma_ndfnz_bezr_tab[2]; //неденежные формы начисления зарплаты
memset(&suma_ndfnz_bezr_tab,'\0',sizeof(suma_ndfnz_bezr_tab));

double suma_ufn_bezr_tab[2]; //сумма на которую увеличился фонд облагаемый изза неденежных форм начисления зарплаты
memset(&suma_ufn_bezr_tab,'\0',sizeof(suma_ufn_bezr_tab));
double suma_ufn_bezr[2]; //сумма на которую увеличился фонд облагаемый изза неденежных форм начисления зарплаты
memset(&suma_ufn_bezr,'\0',sizeof(suma_ufn_bezr));

double suma_boln_ntm=0.; //Сумма больничных не текущего месяца
double suma_boln_ntm_b=0.; //Сумма больничных не текущего месяца Бюджет

double    sbolno=0.;  //Общая сумма больничных
double    sbolnpp=0.; //Сумма больничных предыдущих периодов
double    sumpenpp=0.; //Сумма пенсионных в счёт предыдущих периодов
masiv_din_double KODNVPENSUM; /*Коды не входящие в расчёт пенсионного отчисления*/
masiv_din_double KODBZRNVSUM; //Коды не входящие в расчёт отчислений на безработицу
masiv_din_double KODSOCSTRNVSUM; //Коды не входящие в расчёт соцстраха

long      tabn=0;
short     prn=0;
short     knah=0;
double    suma=0.;
double    bb,bb1;
short     metkabezr=0,metkabezrb=0;

sprintf(imaf,"pensoc%d.lst",getpid());

if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }
iceb_t_zagolov(gettext("Расчёт баз налогообложения для соц. отчислений"),0,0,0,0,0,0,ff);
fprintf(ff,"Дата %d.%d\n",mr,gr);

if(knnf != NULL)
 {
  class iceb_tu_str naim("");
  fprintf(ff,"%s:\n",gettext("Коды неденежных форм начисления зарплаты"));
  for(int nom=0; nom < knnf[0]; nom++)
   {
    sprintf(strsql,"select naik from Nash where kod=%d",knnf[nom+1]);
    if(sql_readkey(&bd,strsql,&row1,&cur1) == 1)
      naim.new_plus(row1[0]);
    else
      naim.new_plus("");
    fprintf(ff,"%2d %s\n",knnf[nom+1],naim.ravno());
   }
 }

char imaf_pr_soc1[64]; //Файд в который будут выгружены работники у которых сумма зарплаты в 1-вом диапазоне
char imaf_pr_soc2[64]; //Файд в который будут выгружены работники у которых сумма зарплаты в 2-вом диапазоне
sprintf(imaf_pr_soc1,"prsoc1%d.lst",getpid());
sprintf(imaf_pr_soc2,"prsoc2%d.lst",getpid());
FILE *ff_pr_soc1;
FILE *ff_pr_soc2;

if((ff_pr_soc1 = fopen(imaf_pr_soc1,"w")) == NULL)
 {
  error_op_nfil(imaf_pr_soc1,errno,"");
  return(1);
 }

if((ff_pr_soc2 = fopen(imaf_pr_soc2,"w")) == NULL)
 {
  error_op_nfil(imaf_pr_soc2,errno,"");
  return(1);
 }
class iceb_tu_str fio("");
double	ogrzp[2]={0.,0.}; /*Разграниечение зарплаты для расчёта пенсионных*/
sprintf(strsql,"select pm,ms from Zarmzpm where data <= '%04d-%02d-%d' order by data desc limit 1",gr,mr,1);
if(readkey(strsql,&row,&curr) > 0)
 {

  if(gr <= 2006)
   ogrzp[0]=150;
  else
    ogrzp[0]=atof(row[0]);

  ogrzp[1]=atof(row[1]);

 }


class zar_read_tn1h nastr;
zar_read_tn1(1,mr,gr,&nastr);

int kodpen=0;  /*Код пенсионных отчислений*/
iceb_t_poldan("Код пенсионного отчисления",&kodpen,"zarnast.alx");

fprintf(ff_pr_soc1,"%s\nРасчёт для соц-страха\nСписок работников у которых начислено до %.2f\n",
iceb_t_get_pnk("00",0),nastr.prog_min_tek);
fprintf(ff_pr_soc2,"%s\nРасчёт для соц-страха\nСписок работников у которых начислено больше %.2f\n",
iceb_t_get_pnk("00",0),nastr.prog_min_tek);
double itogo_suma_soc1[2];
double itogo_suma_soc2[2];
memset(&itogo_suma_soc1,'\0',sizeof(itogo_suma_soc1));
memset(&itogo_suma_soc2,'\0',sizeof(itogo_suma_soc2));
while(cur.read_cursor(&row) != 0)
 {
  strzag(LINES-1,0,kolstr,++kolstr1);
  tabn=atol(row[0]);

  sprintf(strsql,"select fio from Kartb where tabn=%s",row[0]);
  if(readkey(strsql,&row1,&cur1) == 1)
   fio.new_plus(row1[0]);
  else
   fio.new_plus("");
    
  sprintf(strsql,"select prn,knah,suma,shet,godn,mesn from Zarp \
where tabn=%ld and datz >= '%04d-%d-01' and datz <= '%04d-%d-31' \
and suma <> 0.",tabn,gr,mr,gr,mr);

  if((kolstr2=cur1.make_cursor(&bd,strsql)) < 0)
   {
    msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
    continue;
   }
  if(kolstr2 == 0)
   continue;
  
  suma_boln_ntm=0.;
  suma_boln_ntm_b=0.;
//  metkamatpom=0;
  metkabezr=metkabezrb=0;
  memset(sumapnaltab,'\0',sizeof(sumapnaltab));
  memset(sumasnaltab,'\0',sizeof(sumasnaltab));
  memset(sumabnaltab,'\0',sizeof(sumabnaltab));

  memset(sumanahtab,'\0',sizeof(sumanahtab));
  memset(pensnvrtab,'\0',sizeof(pensnvrtab));
  memset(socnvrtab,'\0',sizeof(socnvrtab));
  memset(bezrnvrtab,'\0',sizeof(bezrnvrtab));

  memset(&suma_ndfnz_pens_tab,'\0',sizeof(suma_ndfnz_pens_tab));
  memset(&suma_ndfnz_socstr_tab,'\0',sizeof(suma_ndfnz_socstr_tab));
  memset(&suma_ndfnz_bezr_tab,'\0',sizeof(suma_ndfnz_bezr_tab));

  while(cur1.read_cursor(&row1) != 0)
   {
/*
    printw("%s %s %s %s %s %s\n",
    row1[0],row1[1],row1[2],row1[3],row1[4],row1[5]);
*/    
    prn=atoi(row1[0]);
    knah=atoi(row1[1]);
    suma=atof(row1[2]);
    godpp=atoi(row1[4]);
    mespp=atoi(row1[5]);
    if(prn == 1) //Начисления
     {
      sumanahtab[0]+=suma;
      if(proverka(shetb,row1[3],0,1) == 0)
        sumanahtab[1]+=suma;

      suma_ndfnz_pens_tab[0]+=knnfnds(1,knah,row1[3],suma,&suma_ndfnz_pens_tab[1],0);
      if(provkod(kodbl,knah) >= 0 && (mespp != mr || godpp != gr )) 
       {
        suma_boln_ntm+=suma;
        if(proverka(shetb,row1[3],0,1) == 0)
          suma_boln_ntm_b+=suma;
       }       
      suma_ndfnz_socstr_tab[0]+=knnfnds(1,knah,row1[3],suma,&suma_ndfnz_socstr_tab[1],0);
      suma_ndfnz_bezr_tab[0]+=knnfnds(1,knah,row1[3],suma,&suma_ndfnz_bezr_tab[1],0);

      if(provkod(kodbl,knah) >= 0)
       {
        sbolno+=suma;      
        if(godpp != gr || mespp != mr)
          sbolnpp+=suma;      
        
       }
     }

    if(prn == 2) //Удержания
     {

      if(provkod(kuvvr_pens_sfz,knah) >= 0)
       {
        pensnvrtab[0]+=suma; //Так как удержание отрицательное, то для уменьшения суммы его надо просто прибавить
        if(proverka(shetbu,row1[3],0,1) == 0)
          pensnvrtab[1]+=suma;

       }

      if(knah == kodpen)
       {
        sumapnaltab[0]+=suma;
        if(proverka(shetbu,row1[3],0,1) == 0)
         {
          sumapnaltab[1]+=suma;
         }
        if(godpp != gr || mespp != mr)
          sumpenpp+=suma;
       }

      if(knah == kodsocstr)
       {
        sumasnaltab[0]+=suma;
        if(proverka(shetbu,row1[3],0,1) == 0)
          sumasnaltab[1]+=suma;
       }
      if(knah == kodbzr)
       {
        metkabezr=1;
        sumabnaltab[0]+=suma;
        if(proverka(shetbu,row1[3],0,1) == 0)
         {
          sumabnaltab[1]+=suma;
          metkabezrb=1;
         }
       }


     }
   }

  sumapnal[0]+=sumapnaltab[0];
  sumapnal[1]+=sumapnaltab[1];

  sumasnal[0]+=sumasnaltab[0];
  sumasnal[1]+=sumasnaltab[1];

  sumabnal[0]+=sumabnaltab[0];
  sumabnal[1]+=sumabnaltab[1];

  sumanah[0]+=sumanahtab[0];
  sumanah[1]+=sumanahtab[1];


  pensnvr[0]+=pensnvrtab[0];
  pensnvr[1]+=pensnvrtab[1];

  socnvr[0]+=socnvrtab[0];
  socnvr[1]+=socnvrtab[1];

  bezrnvr[0]+=bezrnvrtab[0];
  bezrnvr[1]+=bezrnvrtab[1];


  suma_ndfnz_pens[0]+=suma_ndfnz_pens_tab[0];
  suma_ndfnz_pens[1]+=suma_ndfnz_pens_tab[1];

  suma_ndfnz_socstr[0]+=suma_ndfnz_socstr_tab[0];
  suma_ndfnz_socstr[1]+=suma_ndfnz_socstr_tab[1];

  suma_ndfnz_bezr[0]+=suma_ndfnz_bezr_tab[0];
  suma_ndfnz_bezr[1]+=suma_ndfnz_bezr_tab[1];
  
  suma_ufn_pens_tab[0]=bb=sumanahtab[0]-pensnvrtab[0];
  suma_ufn_pens_tab[1]=bb1=sumanahtab[1]-pensnvrtab[1];
  bb=okrug(bb,0.01);  
  bb1=okrug(bb1,0.01);  
  
  suma_ufn_pens_tab[0]=bb-suma_ufn_pens_tab[0];
  suma_ufn_pens_tab[1]=bb1-suma_ufn_pens_tab[1];

  suma_ufn_pens[0]+=suma_ufn_pens_tab[0];
  suma_ufn_pens[1]+=suma_ufn_pens_tab[1];
  
  memset(&sumaogr,'\0',sizeof(sumaogr));

  if(bb-suma_boln_ntm > ogrzp[1])
   {
    printw("Превышение для %ld\n",tabn);
    refresh();
    sumaogr[0]=bb-suma_boln_ntm-ogrzp[1];
//    printw("sumaprevm[0]=%f\n",sumaprevm[0]);
    if(metkarnb == 0) //Пропорциональная схема расчёта
      sumaogr[1]=(bb-suma_boln_ntm-ogrzp[1])*bb1/bb;
   }

  if(metkarnb == 1 && bb1 > ogrzp[1]) //Последовательная схема расчёта
      sumaogr[1]=bb1-ogrzp[1];

  sumaprevm[0]+=sumaogr[0];
  sumaprevm[1]+=sumaogr[1];
  
  bb-=sumaogr[0];
  bb1-=sumaogr[1];
  
  if(bb <= ogrzp[0])
   {
    sumvrpens1[0]+=bb;
    sumvrpens1[1]+=bb1;
    sumapnal1[0]+=sumapnaltab[0];
    sumapnal1[1]+=sumapnaltab[1];
   }
  else
   {
    sumapnal2[0]+=sumapnaltab[0];
    sumapnal2[1]+=sumapnaltab[1];
    if(bb <= ogrzp[1])
     {
      sumvrpens2[0]+=bb;
      sumvrpens2[1]+=bb1;
     }
    else   
     {
      /***************
      Сумма больше максимального ограничения.
      В этой сумме могут быть больничные предыдущий месяцев
      В поэтому нужно брасть сумму ограничения плюс сумму на которую она должна увеличиться 
      из-за больничных предыдущих периодов
      **************/      
      double kor_sum=0.;
      double kor_sum_b=0.;
      if(suma_boln_ntm > 0.) //Значит в сумме включены больничные предыдущих месяцев
       {
        if(bb-ogrzp[1] >= suma_boln_ntm)
         kor_sum=suma_boln_ntm;
        else
         kor_sum=bb-ogrzp[1];

        if(bb1-ogrzp[1] >= suma_boln_ntm_b)
         kor_sum_b=suma_boln_ntm_b;
        else
         kor_sum_b=bb1-ogrzp[1];
       }
       
      //Делим превышение пропорционально
      if(metkarnb == 0) //Пропорциональная схема расчёта
       {
        sumvrpens2[0]+=bb*(ogrzp[1]+kor_sum)/(bb+bb1);
        sumvrpens2[1]+=bb1*(ogrzp[1]+kor_sum)/(bb+bb1);
       }
      if(metkarnb == 1) //Последовательная схема расчёта
       {
        sumvrpens2[0]+=ogrzp[1]+kor_sum;
        if(bb1 > ogrzp[1])
         sumvrpens2[1]+=ogrzp[1]+kor_sum_b;
       }
     }
   }


  //соцстрах
//  suma_ufn_socstr_tab[0]=bb=sumanahtab[0]-socnvrtab[0]-nmatpomtab[0];
//  suma_ufn_socstr_tab[1]=bb1=sumanahtab[1]-socnvrtab[1]-nmatpomtab[1];
  suma_ufn_socstr_tab[0]=bb=sumanahtab[0]-socnvrtab[0];
  suma_ufn_socstr_tab[1]=bb1=sumanahtab[1]-socnvrtab[1];

  
  suma_ufn_socstr_tab[0]=bb-suma_ufn_socstr_tab[0];
  suma_ufn_socstr_tab[1]=bb1-suma_ufn_socstr_tab[1];

  suma_ufn_socstr[0]+=suma_ufn_socstr_tab[0];
  suma_ufn_socstr[1]+=suma_ufn_socstr_tab[1];

  memset(&sumaogr,'\0',sizeof(sumaogr));

  if(bb > ogrzp[1])
   {
    sumaogr[0]=bb-ogrzp[1];
    printw("Превышение %.2f для соцстраха Табельный номер %ld\n\
%.2f-%.2f=%.2f\n",
    ogrzp[1],tabn,bb,ogrzp[1],sumaogr[0]);

    if(metkarnb == 0) //Пропорциональная схема расчёта
      sumaogr[1]=(bb-ogrzp[1])*bb1/bb;
   }

  if(metkarnb == 1 && bb1 > ogrzp[1] ) //Последовательная схема расчёта
      sumaogr[1]=bb1-ogrzp[1];
  sumaprevmsoc[0]+=sumaogr[0];
  sumaprevmsoc[1]+=sumaogr[1];
 
  bb-=sumaogr[0];
  bb1-=sumaogr[1];


  if(bb <= nastr.prog_min_tek)
   {
    sumvrsoc1[0]+=bb;
    sumvrsoc1[1]+=bb1;

    fprintf(ff_pr_soc1,"%4s %-*.*s %8.2f %5.2f\n",
    row[0],
    iceb_tu_kolbait(20,fio.ravno()),iceb_tu_kolbait(20,fio.ravno()),fio.ravno(),
    bb,sumasnaltab[0]);
    itogo_suma_soc1[0]+=bb;
    itogo_suma_soc1[1]+=sumasnaltab[0];
    
   }
  else
   {
    if(bb <= ogrzp[1])
     {
      sumvrsoc2[0]+=bb;
      sumvrsoc2[1]+=bb1;
      fprintf(ff_pr_soc2,"%4s %-*.*s %8.2f %5.2f\n",
      row[0],  
      iceb_tu_kolbait(20,fio.ravno()),iceb_tu_kolbait(20,fio.ravno()),fio.ravno(),
      bb,sumasnaltab[0]);
      
      itogo_suma_soc2[0]+=bb;
      itogo_suma_soc2[1]+=sumasnaltab[0];
     }
    else   
     {
      //Делим превышение пропорционально
      if(metkarnb == 0) //Пропорциональная схема расчёта
       {
        sumvrsoc2[0]+=bb*ogrzp[1]/(bb+bb1);
        sumvrsoc2[1]+=bb1*ogrzp[1]/(bb+bb1);
       }
      if(metkarnb == 1) //Последовательная схема расчёта
       {
        sumvrsoc2[0]+=ogrzp[1];
        if(bb1 > ogrzp[1])
         sumvrsoc2[1]+=ogrzp[1];
       }
      fprintf(ff_pr_soc2,"%4s %-*.*s %8.2f %5.2f превышение максимальной суммы\n",
      row[0],
      iceb_tu_kolbait(20,fio.ravno()),iceb_tu_kolbait(20,fio.ravno()),fio.ravno(),
      ogrzp[1],sumasnaltab[0]);
      itogo_suma_soc2[0]+=ogrzp[1];
      itogo_suma_soc2[1]+=sumasnaltab[0];

     }

   }  

  if(bb <= nastr.prog_min_tek)
   {
    sumasnal1[0]+=sumasnaltab[0];
    sumasnal1[1]+=sumasnaltab[1];
   }
  else
   {
    sumasnal2[0]+=sumasnaltab[0];
    sumasnal2[1]+=sumasnaltab[1];
   }


  //Безработица*******************************

  suma_ufn_bezr_tab[0]=bb=sumanahtab[0]-bezrnvrtab[0];
  suma_ufn_bezr_tab[1]=bb1=sumanahtab[1]-bezrnvrtab[1];

  
  suma_ufn_bezr_tab[0]=bb-suma_ufn_bezr_tab[0];
  suma_ufn_bezr_tab[1]=bb1-suma_ufn_bezr_tab[1];

  suma_ufn_bezr[0]+=suma_ufn_bezr_tab[0];
  suma_ufn_bezr[1]+=suma_ufn_bezr_tab[1];

  memset(&sumaogr,'\0',sizeof(sumaogr));
  if(bb > ogrzp[1])
   {
    sumaogr[0]=bb-ogrzp[1];
//    printw("sumaprevmsoc[0]=%f\n",sumaprevmsoc[0]);
    if(metkarnb == 0) //Пропорциональная схема расчёта
       sumaogr[1]=sumaogr[0]*bb1/bb;
   }

  if(metkarnb == 1 && bb1 > ogrzp[1]) //Последовательная схема расчёта
       sumaogr[1]=bb1-ogrzp[1];

  sumaprevmbez[0]+=sumaogr[0];
  sumaprevmbez[1]+=sumaogr[1];

  if(metkabezr == 0)
   {
    sumanvbezr[0]+=bb-sumaogr[0];
    if(metkabezrb == 0)
      sumanvbezr[1]+=bb1-sumaogr[1];
//    printw("%ld %.2f %.2f\n",tabn,bb-sumaogr[0],bb1-sumaogr[1]);
//    OSTANOV();
   }
   
  if(bb <= ogrzp[0])
   {
    sumvrbez1+=bb;
   }
  else
   {
    if(bb <= ogrzp[1])
      sumvrbez2+=bb;
    else   
      sumvrbez2+=ogrzp[1];
   }

 }

fprintf(ff_pr_soc1,"%*s %8.2f %5.2f\n",iceb_tu_kolbait(15,gettext("Итого")),gettext("Итого"),itogo_suma_soc1[0],itogo_suma_soc1[1]);
fprintf(ff_pr_soc2,"%*s %8.2f %5.2f\n",iceb_tu_kolbait(15,gettext("Итого")),gettext("Итого"),itogo_suma_soc2[0],itogo_suma_soc2[1]);

podpis(ff_pr_soc1);
podpis(ff_pr_soc2);

fclose(ff_pr_soc1);
fclose(ff_pr_soc2);


fprintf(ff,"%s:\n",gettext("Коды не входящие в расчёт пенсионного отчисления"));
double itogonvr=0.;

fprintf(ff,"%*s %8.2f\n",iceb_tu_kolbait(44,gettext("Итого")),gettext("Итого"),itogonvr);

fprintf(ff,"%s %.2f %.2f\n",gettext("Сумма неденежных форм начисления зарплаты"),
suma_ndfnz_pens[0],suma_ndfnz_pens[1]);

double sumavras[2];
//sumavras[0]=sumanah[0]-pensnvr[0]-nmatpom[0]-sumaprevm[0]+suma_ufn_pens[0];
//sumavras[1]=sumanah[1]-pensnvr[1]-nmatpom[1]-sumaprevm[1]+suma_ufn_pens[1];
sumavras[0]=sumanah[0]-pensnvr[0]-sumaprevm[0]+suma_ufn_pens[0];
sumavras[1]=sumanah[1]-pensnvr[1]-sumaprevm[1]+suma_ufn_pens[1];


sprintf(strsql,"%s %.2f",gettext("Сумма превышающая"),ogrzp[1]);

fprintf(ff,"\n%s:\n\
%43s %s %s\n\
%-*s %10.2f %10.2f %10.2f\n\
%-*s %10.2f %10.2f %10.2f\n\
%-*s %10.2f %10.2f %10.2f\n\
%-*s %10.2f %10.2f %10.2f\n\n\
%-*s %10.2f %10.2f %10.2f\n",
gettext("Пенсионный фонд"),
" ",
gettext("Хозрасчёт"),
gettext("Бюджет"),

iceb_tu_kolbait(43,gettext("Общая сумма начислений")),gettext("Общая сумма начислений"),
sumanah[0],
sumanah[0]-sumanah[1],
sumanah[1],

iceb_tu_kolbait(43,gettext("Сумма увеличения фонда")),gettext("Сумма увеличения фонда"),
suma_ufn_pens[0],
suma_ufn_pens[0]-suma_ufn_pens[1],
suma_ufn_pens[1],

iceb_tu_kolbait(43,gettext("Сумма не входящая в расчёт пенсионного")),gettext("Сумма не входящая в расчёт пенсионного"),
pensnvr[0],
pensnvr[0]-pensnvr[1],
pensnvr[1],
/**********
gettext("Необлагаемая благотворительная помощь"),
nmatpom[0],
nmatpom[0]-nmatpom[1],
nmatpom[1],
***********/
iceb_tu_kolbait(43,strsql),strsql,
sumaprevm[0],
sumaprevm[0]-sumaprevm[1],
sumaprevm[1],

iceb_tu_kolbait(43,gettext("Сумма взятая в расчёт")),gettext("Сумма взятая в расчёт"),
sumavras[0],
sumavras[0]-sumavras[1],
sumavras[1]);

fprintf(ff,"\
%-*s %10.2f %10.2f %10.2f\n",
iceb_tu_kolbait(43,gettext("Сумма пенсионного отчисления с работника")),gettext("Сумма пенсионного отчисления с работника"),
sumapnal[0],sumapnal[0]-sumapnal[1],sumapnal[1]);

sprintf(strsql,"%s %s %.2f",
gettext("Сумма"),
gettext("до"),ogrzp[0]);

fprintf(ff,"\n\
%-*s %10.2f %10.2f %10.2f\n",
iceb_tu_kolbait(43,strsql),strsql,sumvrpens1[0],sumvrpens1[0]-sumvrpens1[1],sumvrpens1[1]);

fprintf(ff,"\
%-*s %10.2f %10.2f %10.2f\n",
iceb_tu_kolbait(43,gettext("Сумма налога")),gettext("Сумма налога"),
sumapnal1[0],sumapnal1[0]-sumapnal1[1],sumapnal1[1]);

sprintf(strsql,"%s  %.2f => %.2f",gettext("Сумма"),ogrzp[0],ogrzp[1]);
fprintf(ff,"\n\
%-*s %10.2f %10.2f %10.2f\n",
iceb_tu_kolbait(34,strsql),strsql,sumvrpens2[0],sumvrpens2[0]-sumvrpens2[1],sumvrpens2[1]);

fprintf(ff,"\
%-43s %10.2f %10.2f %10.2f\n",
gettext("Сумма налога"),
sumapnal2[0],sumapnal2[0]-sumapnal2[1],sumapnal2[1]);

fprintf(ff,"\n\
%-*s %10.2f\n\
%-*s %10.2f\n\
%-*s %10.2f\n",
iceb_tu_kolbait(34,gettext("Сумма больничных")),gettext("Сумма больничных"),
sbolno,
iceb_tu_kolbait(34,gettext("Сумма больничных предыдущих периодов")),gettext("Сумма больничных предыдущих периодов"),
sbolnpp,
iceb_tu_kolbait(34,gettext("Сумма пенсионных в счёт пред-щих периодов")),gettext("Сумма пенсионных в счёт пред-щих периодов"),
sumpenpp);

/********************************/
fprintf(ff,"\n--------------------------------------------------------------------------\n");

fprintf(ff,"%s:\n",gettext("Коды не входящие в расчёт соцстраха"));
itogonvr=0.;

itogonvr=0.;
/**************
if(kodsocstrnv != NULL)
 for(i=1; i <= kodsocstrnv[0]; i++)
  {
   memset(naik,'\0',sizeof(naik));
   sprintf(strsql,"select naik from Nash where kod=%d",kodsocstrnv[i]);
   if(sql_readkey(&bd,strsql,&row,&curr) == 1)
     strncpy(naik,row[0],sizeof(naik)-1);   
   fprintf(ff,"%3d %-*s %8.2f\n",
   kodsocstrnv[i],
   iceb_tu_kolbait(40,naik),naik,
   KODSOCSTRNVSUM.ravno(i-1));
   itogonvr+=KODSOCSTRNVSUM.ravno(i-1);
  }  
***************/
fprintf(ff,"%*s %8.2f\n",iceb_tu_kolbait(44,gettext("Итого")),gettext("Итого"),itogonvr);

fprintf(ff,"%s %.2f %.2f\n",gettext("Сумма неденежных форм начисления зарплаты"),
suma_ndfnz_socstr[0],suma_ndfnz_socstr[1]);

//sumavras[0]=sumanah[0]-socnvr[0]-nmatpom[0]-sumaprevmsoc[0]+suma_ufn_socstr[0];
//sumavras[1]=sumanah[1]-socnvr[1]-nmatpom[1]-sumaprevmsoc[1]+suma_ufn_socstr[1];
sumavras[0]=sumanah[0]-socnvr[0]-sumaprevmsoc[0]+suma_ufn_socstr[0];
sumavras[1]=sumanah[1]-socnvr[1]-sumaprevmsoc[1]+suma_ufn_socstr[1];

sprintf(strsql,"%s %.2f",gettext("Сумма превышающая"),ogrzp[1]);

fprintf(ff,"\n\
%s:\n\
%43s %s %s\n\
%-*s %10.2f %10.2f %10.2f\n\
%-*s %10.2f %10.2f %10.2f\n\
%-*s %10.2f %10.2f %10.2f\n\
%-*s %10.2f %10.2f %10.2f\n\n\
%-*s %10.2f %10.2f %10.2f\n",

gettext("Соцстрах"),
" ",gettext("Хозрасчёт"),gettext("Бюджет"),

iceb_tu_kolbait(43,gettext("Общая сумма начислений")),gettext("Общая сумма начислений"),
sumanah[0],
sumanah[0]-sumanah[1],
sumanah[1],

iceb_tu_kolbait(43,gettext("Сумма увеличения фонда")),gettext("Сумма увеличения фонда"),
suma_ufn_socstr[0],
suma_ufn_socstr[0]-suma_ufn_socstr[1],
suma_ufn_socstr[1],

iceb_tu_kolbait(43,gettext("Сумма не входящая в расчёт соц.страха")),gettext("Сумма не входящая в расчёт соц.страха"),
socnvr[0],
socnvr[0]-socnvr[1],
socnvr[1],
/***********
gettext("Необлагаемая благотворительная помощь"),
nmatpom[0],
nmatpom[0]-nmatpom[1],
nmatpom[1],
***************/

iceb_tu_kolbait(43,strsql),strsql,
sumaprevmsoc[0],
sumaprevmsoc[0]-sumaprevmsoc[1],
sumaprevmsoc[1],

iceb_tu_kolbait(43,gettext("Сумма взятая в расчёт")),gettext("Сумма взятая в расчёт"),
sumavras[0],
sumavras[0]-sumavras[1],
sumavras[1]);

fprintf(ff,"\
%-43s %10.2f %10.2f %10.2f\n",
gettext("Сумма соц. страха с работника"),
sumasnal[0],sumasnal[0]-sumasnal[1],sumasnal[1]);

//***************************
sprintf(strsql,"%s %s %.2f",
gettext("Сумма"),
gettext("до"),nastr.prog_min_tek);

fprintf(ff,"\n%-*s %10.2f %10.2f %10.2f\n",
iceb_tu_kolbait(43,strsql),strsql,sumvrsoc1[0],sumvrsoc1[0]-sumvrsoc1[1],sumvrsoc1[1]);

fprintf(ff,"\
%-*s %10.2f %10.2f %10.2f\n",
iceb_tu_kolbait(43,gettext("Сумма налога")),gettext("Сумма налога"),
sumasnal1[0],sumasnal1[0]-sumasnal1[1],sumasnal1[1]);

sprintf(strsql,"%s  %.2f => %.2f",gettext("Сумма"),nastr.prog_min_tek,ogrzp[1]);

fprintf(ff,"\n%-*s %10.2f %10.2f %10.2f\n",
iceb_tu_kolbait(43,strsql),strsql,sumvrsoc2[0],sumvrsoc2[0]-sumvrsoc2[1],sumvrsoc2[1]);

fprintf(ff,"\
%-*s %10.2f %10.2f %10.2f\n",
iceb_tu_kolbait(43,gettext("Сумма налога")),gettext("Сумма налога"),
sumasnal2[0],sumasnal2[0]-sumasnal2[1],sumasnal2[1]);
//**************************************/

fprintf(ff,"\n--------------------------------------------------------------------------\n");

fprintf(ff,"%s:\n",
gettext("Коды не входящие в расчёт отчисления на безработицу"));
itogonvr=0.;
/*****************
if(kodbzrnv != NULL)
 for(i=1; i <= kodbzrnv[0]; i++)
  {
   memset(naik,'\0',sizeof(naik));
   sprintf(strsql,"select naik from Nash where kod=%d",kodbzrnv[i]);
   if(sql_readkey(&bd,strsql,&row,&curr) == 1)
     strncpy(naik,row[0],sizeof(naik)-1);   
   fprintf(ff,"%3d %-*s %8.2f\n",
   kodbzrnv[i],
   iceb_tu_kolbait(40,naik),naik,
   KODBZRNVSUM.ravno(i-1));
   itogonvr+=KODBZRNVSUM.ravno(i-1);
  }  
******************/
fprintf(ff,"%*s %8.2f\n",iceb_tu_kolbait(44,gettext("Итого")),gettext("Итого"),itogonvr);

fprintf(ff,"%s %.2f %.2f\n",gettext("Сумма неденежных форм начисления зарплаты"),
suma_ndfnz_bezr[0],suma_ndfnz_bezr[1]);

sumavras[0]=sumanah[0]-bezrnvr[0]-sumaprevmbez[0]-sumanvbezr[0]+suma_ufn_bezr[0];
sumavras[1]=sumanah[1]-bezrnvr[1]-sumaprevmbez[1]-sumanvbezr[1]+suma_ufn_bezr[1];

sprintf(strsql,"%s %.2f",gettext("Сумма превышающая"),ogrzp[1]);

fprintf(ff,"\n\
%s:\n\
%43s %s %s\n\
%*s %10.2f %10.2f %10.2f\n\
%*s %10.2f %10.2f %10.2f\n\
%*s %10.2f %10.2f %10.2f\n\
%*s %10.2f %10.2f %10.2f\n\
%*s %10.2f %10.2f %10.2f\n\n\
%*s %10.2f %10.2f %10.2f\n",

gettext("Фонд безработицы"),
" ",gettext("Хозрасчёт"),gettext("Бюджет"),

iceb_tu_kolbait(34,gettext("Общая сумма начислений")),gettext("Общая сумма начислений"),
sumanah[0],
sumanah[0]-sumanah[1],
sumanah[1],

iceb_tu_kolbait(34,gettext("Сумма увеличения фонда")),gettext("Сумма увеличения фонда"),
suma_ufn_bezr[0],
suma_ufn_bezr[0]-suma_ufn_bezr[1],
suma_ufn_bezr[1],

iceb_tu_kolbait(34,gettext("Сумма не входящая в расчёт безработицы")),gettext("Сумма не входящая в расчёт безработицы"),
bezrnvr[0],
bezrnvr[0]-bezrnvr[1],
bezrnvr[1],
/*************
gettext("Необлагаемая благотворительная помощь"),
nmatpom[0],
nmatpom[0]-nmatpom[1],
nmatpom[1],
**************/
iceb_tu_kolbait(34,gettext("Сумма пенсионеров и инвалидов")),gettext("Сумма пенсионеров и инвалидов"),
sumanvbezr[0],
sumanvbezr[0]-sumanvbezr[1],
sumanvbezr[1],

iceb_tu_kolbait(34,strsql),strsql,
sumaprevmbez[0],
sumaprevmbez[0]-sumaprevmbez[1],
sumaprevmbez[1],

iceb_tu_kolbait(34,gettext("Сумма взятая в расчёт")),gettext("Сумма взятая в расчёт"),
sumavras[0],
sumavras[0]-sumavras[1],
sumavras[1]);

fprintf(ff,"\
%-*s %10.2f %10.2f %10.2f\n",
iceb_tu_kolbait(34,gettext("Сумма отчисления в фонд безработицы")),gettext("Сумма отчисления в фонд безработицы"),
sumabnal[0],sumabnal[0]-sumabnal[1],sumabnal[1]);

podpis(ff);
fclose(ff);

printw_vr(tmm);


OSTANOV();

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Расчёт баз налогообложения для соц. отчислений"));

oth->spis_imaf.plus(imaf_pr_soc1);
oth->spis_naim.plus(gettext("Список работников у которых зарплата меньше прожиточного минимума"));

oth->spis_imaf.plus(imaf_pr_soc2);
oth->spis_naim.plus(gettext("Список работников у которых зарплата больше прожиточного минимума"));

for(int nom=0; nom < oth->spis_imaf.kolih(); nom++)
 iceb_t_ustpeh(oth->spis_imaf.ravno(nom),3);

return(0);
}
