/*$Id: iceb_t_nn6_start.c,v 5.3 2014/07/31 07:09:27 sasa Exp $*/
/*17.03.2015	26.11.2014	Белых А.И.	iceb_t_nn7_start.c
Печать шапки налоговой накладной  приказ Министерства финансов Украины от 22.11.2014 N 957
Если вернули 0 - шапку сформировали
             1 - нет
             
*/
#include <errno.h>
#include "buhl.h"

int iceb_t_nn7_start_v(class iceb_tu_str *vid_dog,class iceb_tu_str *data_dog,class iceb_tu_str *nom_dog,class iceb_tu_str *sostop,class iceb_tu_str *nevid,class iceb_tu_str *tippr);

int iceb_t_nn7_start(const char *imaf,
short dd,short md,short gd, //дата документа
short dnn,short mnn,short gnn, //Дата налоговой накладной
const char *nomnn, //Номер налоговой накладной
const char *osnov, //Основание
const char *uspr,  //Условие продажи
const char *frop,//Код формы оплаты
const char *kpos,
int tipz,  /*1-приход 2-расход*/
int metka_kop, /*Метка копии 0 - не ставить "Х" 1- копия получателя 2-копия выдавателя*/
const char *kodkontr00,
const char *kod_vid_deqt, /*код вида деятельности*/
FILE **ff)
{
int nomer_st=0;
class iceb_tu_str stroka("");
char strsql[1024];
char data_vipiski[512];
SQL_str row;
SQLCURSOR cur;
class iceb_tu_str nmo(""),nmo1("");  /*Наименование организации*/
class iceb_tu_str gor(""),gor1(""); /*Налоговый адрес*/
class iceb_tu_str inn(""),inn1("");  /*Индивидуальный налоговый номер*/
class iceb_tu_str telef(""),telef1(""); /*Номер телефона*/
class iceb_tu_str nai_for_opl("");
class SQLCURSOR cur_alx;
SQL_str row_alx;
int kolstr=0;
short ddog=0,mdog=0,gdog=0;/*дата договора*/
int nom_nah=0;
class iceb_tu_str nomer_dog("");
class iceb_tu_str vid_dog("");
class iceb_tu_str data_dog("");
class iceb_tu_str nnn1("");
class iceb_tu_str nnn2("");
static class iceb_tu_str tip_prih("");
static class iceb_tu_str sostop("");
static class iceb_tu_str nevid("");
class iceb_tu_str bros("");


if(polen(uspr,&vid_dog,1,':') != 0)
 vid_dog.new_plus(uspr);
polen(uspr,&data_dog,2,':');
polen(uspr,&nomer_dog,3,':');
if(polen(uspr,&bros,4,':') == 0)
 {
  if(polen(bros.ravno(),&tip_prih,2,',') == 0)
   if(tip_prih.getdlinna() > 1)
    nevid.new_plus("X");
 }



if(iceb_t_nn7_start_v(&vid_dog,&data_dog,&nomer_dog,&sostop,&nevid,&tip_prih) != 0)
 return(1);


if(frop[0] != '\0')
 {
  /*Читаем форму оплаты*/
  sprintf(strsql,"select naik from Foroplat \
where kod='%s'",frop);

  if(sql_readkey(&bd,strsql,&row,&cur) != 1)
   {
    sprintf(strsql,"Не знайдена форма оплаты %s !",frop);  
    iceb_t_soob(strsql);
   }
  else
    nai_for_opl.new_plus(row[0]);
 }


/*Читаем реквизиты организации свои */

sprintf(strsql,"select * from Kontragent where kodkon='%s'",kodkontr00);
if(sql_readkey(&bd,strsql,&row,&cur) != 1)
 {
  sprintf(strsql,"%s %s !",
  gettext("Не найден код контрагента"),"00");
  iceb_t_soob(strsql);
 }
else
 {
  if(tipz == 2)
   {
    if(row[16][0] == '\0')
     {
      if(polen(row[1],&nmo,1,'(') != 0)
        nmo.new_plus(row[1]);
     }
    else
      nmo.new_plus(row[16]);

    if(row[14][0] != '\0')
     gor.new_plus(row[14]);
    else
     gor.new_plus(row[3]);

    inn.new_plus(row[8]);
    telef.new_plus(row[10]);
   }

  if(tipz == 1)
   {
    if(row[16][0] == '\0')
      nmo1.new_plus(row[1]);
    else
      nmo1.new_plus(row[16]);

    if(row[14][0] != '\0')
      gor1.new_plus(row[14]);
    else
      gor1.new_plus(row[3]);
    inn1.new_plus(row[8]);
    telef1.new_plus(row[10]);
   }

 } 


/*Читаем реквизиты организации чужие*/
/*При внутреннем перемещении не читать*/
if(ATOFM(kpos) != 0. || kpos[0] != '0')
 {
  sprintf(strsql,"select * from Kontragent where kodkon='%s'",kpos);
  if(sql_readkey(&bd,strsql,&row,&cur) != 1)
   {
    sprintf(strsql,"%s %s !",gettext("Не найден код контрагента"),kpos);
    iceb_t_soob(strsql);
   }
  else
   {
    if(tipz == 2)
     {
      if(row[16][0] == '\0')
       {
        if(polen(row[1],&nmo1,1,'(') != 0)
          nmo1.new_plus(row[1]);
       }
      else
        nmo1.new_plus(row[16]);

      if(row[14][0] != '\0')
        gor1.new_plus(row[14]);
      else
        gor1.new_plus(row[3]);
        
      inn1.new_plus(row[8]);
      telef1.new_plus(row[10]);
     }
    if(tipz == 1)
     {
      if(row[16][0] == '\0')
        nmo.new_plus(row[1]);
      else
        nmo.new_plus(row[16]);

      if(row[14][0] != '\0')
        gor.new_plus(row[14]);
      else
        gor.new_plus(row[3]);
      inn.new_plus(row[8]);
      telef.new_plus(row[10]);
     }
    
   }
  VVOD SOOB(1);
  int i=0;  
  if(inn1.ravno()[0] == '\0')
   {
    i++;
    sprintf(strsql,gettext("Для контрагента %s не введён индивидуальный налоговый номер !"),kpos);
    SOOB.VVOD_SPISOK_add_MD(strsql);
   }
  if(i != 0)
    soobshw(&SOOB,stdscr,-1,-1,0,1);
 }

sprintf(strsql,"select str from Alx where fil='nn7_start.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"nn7_start.alx");
  iceb_t_soob(strsql);
  return(1);
 }


if((*ff = fopen(imaf,"w")) == NULL)
   {
    error_op_nfil(imaf,errno,"");
    return(1);
   }
fprintf(*ff,"\x1B\x33%c",20); /*Уменьшение межстрочного интервала*/
//fprintf(*ff,"\x1B\x33%c",24); /*Уменьшение межстрочного интервала*/
fprintf(*ff,"\x1B\%c%c",'[',10); /*Уменьшение высоты символа*/
memset(strsql,'\0',sizeof(strsql));
if(dnn != 0)
 {
  mesc(mnn,1,strsql);
  sprintf(data_vipiski,"%02d%02d%04d",dnn,mnn,gnn);
 }
else
 {
  mesc(md,1,strsql);
  sprintf(data_vipiski,"%02d%02d%04d",dd,md,gd);
 }

while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
     continue;

  nomer_st+=1;
  stroka.new_plus(row_alx[0]);
  
  switch(nomer_st)
   {  
    case 2: /*складаэться оператором*/
      iceb_tu_vstav(&stroka,sostop.ravno(),56,57,1);
      break;

    case 5: /*не выдаеться покупателю*/
      iceb_tu_vstav(&stroka,nevid.ravno(),56,57,1 );
      break;

    case 7: /*тип причины*/
      iceb_tu_vstav(&stroka,tip_prih.ravno(),55,64,2 );
      break;


    case 11: /*Дата складання - номер налоговой накладной*/
      iceb_tu_vstav(&stroka,data_vipiski,58,73,2 );
      iceb_tu_vstav(&stroka,kod_vid_deqt,137,138,1);
      
      if(polen(nomnn,&nnn1,1,'/') != 0)
        nnn1.new_plus(nomnn);
      else
        polen(nomnn,&nnn2,2,'/');
        
      sprintf(strsql,"%*s",iceb_tu_kolbait(7,nnn1.ravno()),nnn1.ravno());
      iceb_tu_vstav(&stroka,strsql,119,137,2 );
      if(nnn2.getdlinna() > 1)
       {
        sprintf(strsql,"%*s",iceb_tu_kolbait(4,nnn2.ravno()),nnn2.ravno());
        iceb_tu_vstav(&stroka,strsql,143,152,2 );
       }      
      break;


    case 16: /*первая строка наименования продавца и покупателя*/
      sprintf(strsql,"%*.*s",iceb_tu_kolbait(61,nmo.ravno()),iceb_tu_kolbait(61,nmo.ravno()),nmo.ravno());
      iceb_tu_vstav(&stroka,strsql,19,79,1 );
      sprintf(strsql,"%*.*s",iceb_tu_kolbait(63,nmo1.ravno()),iceb_tu_kolbait(63,nmo1.ravno()),nmo1.ravno());
      iceb_tu_vstav(&stroka,strsql,101,163,1 );
      break;
      
    case 17:  /*вторая строка наименования продавца и покупателя*/
      if(iceb_tu_strlen(nmo.ravno()) > 61)
       {
        sprintf(strsql,"%*.*s",iceb_tu_kolbait(61,iceb_tu_adrsimv(61,nmo.ravno())),iceb_tu_kolbait(61,iceb_tu_adrsimv(61,nmo.ravno())),iceb_tu_adrsimv(61,nmo.ravno()));
        iceb_tu_vstav(&stroka,strsql,19,79,1 );
       }
      if(iceb_tu_strlen(nmo1.ravno()) > 63)
       {
        sprintf(strsql,"%*.*s",iceb_tu_kolbait(63,iceb_tu_adrsimv(63,nmo1.ravno())),iceb_tu_kolbait(63,iceb_tu_adrsimv(63,nmo1.ravno())),iceb_tu_adrsimv(63,nmo1.ravno()));
        iceb_tu_vstav(&stroka,strsql,101,163,1 );
       }
      break;

    case 18:  /*третя строка ниаменования продвца и покупателя*/
      if(iceb_tu_strlen(nmo.ravno()) > 122)
       {
        sprintf(strsql,"%*.*s",iceb_tu_kolbait(61,iceb_tu_adrsimv(122,nmo.ravno())),iceb_tu_kolbait(61,iceb_tu_adrsimv(122,nmo.ravno())),iceb_tu_adrsimv(122,nmo.ravno()));
        iceb_tu_vstav(&stroka,strsql,19,79,1 );
       }
      if(iceb_tu_strlen(nmo1.ravno()) > 126)
       {
        sprintf(strsql,"%*.*s",iceb_tu_kolbait(53,iceb_tu_adrsimv(126,nmo1.ravno())),iceb_tu_kolbait(63,iceb_tu_adrsimv(126,nmo1.ravno())),iceb_tu_adrsimv(126,nmo1.ravno()));
        iceb_tu_vstav(&stroka,strsql,101,163,1 );
       }
      break;
      
    case 21:  /*индивидуальный налоговый номер*/
      sprintf(strsql,"%*s",iceb_tu_kolbait(12,inn.ravno()),inn.ravno()); /*Для печати со смещением вправо*/
      iceb_tu_vstav(&stroka,strsql,50,74,2 );
      
      sprintf(strsql,"%*s",iceb_tu_kolbait(12,inn1.ravno()),inn1.ravno()); /*Для печати со смещением вправо*/
      iceb_tu_vstav(&stroka,strsql,141,165,2 );
      break;
      
    case 25:  /*первая строка адреса продавца и покупателя*/
      if(iceb_tu_strlen(gor.ravno()) >= 73)
        nom_nah=9;
      else
        nom_nah=81-iceb_tu_strlen(gor.ravno());

      iceb_tu_vstav(&stroka,gor.ravno(),nom_nah,81,1 );

      if(iceb_tu_strlen(gor1.ravno()) >= 73)
       nom_nah=92;
      else
       nom_nah=164-iceb_tu_strlen(gor1.ravno())+1;

      iceb_tu_vstav(&stroka,gor1.ravno(),nom_nah,164,1 );

      break;

    case 26:  /*вторая строка адреса продавца и покупателя*/
      if(iceb_tu_strlen(gor.ravno()) > 73)
        iceb_tu_vstav(&stroka,iceb_tu_adrsimv(73,gor.ravno()),0,9+73,1 );
      if(iceb_tu_strlen(gor1.ravno()) > 73)
        iceb_tu_vstav(&stroka,iceb_tu_adrsimv(73,gor1.ravno()),83,165,1 );
      break;

    case 28: /*номер телефона*/
      sprintf(strsql,"%*s",iceb_tu_kolbait(10,telef.ravno()),telef.ravno());
      iceb_tu_vstav(&stroka,strsql,54,54+19,2 );
      sprintf(strsql,"%*s",iceb_tu_kolbait(10,telef1.ravno()),telef1.ravno());
      iceb_tu_vstav(&stroka,strsql,145,145+19,2 );
      break;

    case 31: /*вид договора*/
      nom_nah=114-iceb_tu_strlen(vid_dog.ravno())+1;
      iceb_tu_vstav(&stroka,vid_dog.ravno(),nom_nah,114,1 );
      rsdat(&ddog,&mdog,&gdog,data_dog.ravno(),1);
      if(ddog != 0)
       {
        memset(strsql,'\0',sizeof(strsql));
        sprintf(strsql,"%02d%02d%04d",ddog,mdog,gdog);
        iceb_tu_vstav(&stroka,strsql,122,138,2 );
       }
      sprintf(strsql,"%*s",iceb_tu_kolbait(22,nomer_dog.ravno()),nomer_dog.ravno()); /*для печати со смещением в право*/
      iceb_tu_vstav(&stroka,strsql,143,163,1 );
      break;

    case 33: /*форма проведения расчётов*/
      nom_nah=165-iceb_tu_strlen(nai_for_opl.ravno())+1;
      iceb_tu_vstav(&stroka,nai_for_opl.ravno(),nom_nah,165,1 );

   }
  fprintf(*ff,"%s",stroka.ravno());
 }

return(0);

}
