/*$Id: snu.c,v 5.19 2013/09/26 09:43:40 sasa Exp $*/
/*20.11.2011	23.03.2005	Белых А.И.	snu.c
Свод по начислениям и удержаниям зарплаты
*/
#include        <errno.h>
#include "buhg.h"

void snu_ras(int metka,masiv_din_int *kod,double *suma,FILE *ff);


int snu(class spis_oth *oth)
{
class iceb_tu_str fiov("");
static class iceb_tu_str dat1("");
static class iceb_tu_str dat2("");
static class iceb_tu_str podr("");
static class iceb_tu_str tabnom("");
static class iceb_tu_str shet("");
static class iceb_tu_str kategor("");
short dt,mt,gt;
int kom=0;
int kom1=0;
char strsql[512];
int tabn;

VVOD VV(0);
VVOD MENU(3);
poltekdat(&dt,&mt,&gt);
if(dat1.ravno()[0] == '\0')
 {
  sprintf(strsql,"%d.%d",mt,gt);
  dat1.new_plus(strsql);
 }
VV.VVOD_SPISOK_add_ZAG(gettext("Распечатка свода начислений и удержаний"));

VV.VVOD_SPISOK_add_data(dat1.ravno(),8);
VV.VVOD_SPISOK_add_data(dat2.ravno(),8);
VV.VVOD_SPISOK_add_data(podr.ravno(),128);
VV.VVOD_SPISOK_add_data(tabnom.ravno(),128);
VV.VVOD_SPISOK_add_data(shet.ravno(),128);
VV.VVOD_SPISOK_add_data(kategor.ravno(),128);


VV.VVOD_SPISOK_add_MD(gettext("Дата начала.....(м.г).."));//0
VV.VVOD_SPISOK_add_MD(gettext("Дата конца......(м.г).."));//1
VV.VVOD_SPISOK_add_MD(gettext("Код подразделения.(,,)."));//2
VV.VVOD_SPISOK_add_MD(gettext("Табельный номер..(,,).."));//3
VV.VVOD_SPISOK_add_MD(gettext("Счёт.............(,,).."));//4
VV.VVOD_SPISOK_add_MD(gettext("Категории........(,,).."));//5



naz:;

clear(); 

helstr(LINES-1,0,"F1",gettext("помощь"),
"F2/+",gettext("расчёт"),
"F3",gettext("реквизиты"),
"F4",gettext("очистить"),
"F10",gettext("выход"),NULL);

kom=VV.vvod(0,1,1,-1,-1);

dat1.new_plus(VV.data_ravno(0));
dat2.new_plus(VV.data_ravno(1));
podr.new_plus(VV.data_ravno(2));
tabnom.new_plus(VV.data_ravno(3));
shet.new_plus(VV.data_ravno(4));
kategor.new_plus(VV.data_ravno(5));

class iceb_tu_str naim("");

switch(kom)
 {
  case FK1:   /*Помощь*/
   GDITE();
   iceb_t_pdoc("zarp4_9.txt");
   goto naz;

  case FK10:
  case ESC:
   return(1);

  case FK2:
  case PLU:
   break;

  case FK3:
    MENU.VVOD_delete();
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка подразделений"));//0
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка табельных номеров"));//1
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка счетов"));//2
    MENU.VVOD_SPISOK_add_MD(gettext("Просмотр списка категорий"));//3
    MENU.VVOD_SPISOK_add_MD(gettext("Выход"));//4

    clearstr(LINES-1,0);
    
    kom1=0;
    while(menu3w(stdscr,&MENU,&kom1,-1,-1,0) != 0);

    switch (kom1)
     {
      case 4 :
      case -1:
       goto naz;

      case 0 :
        vibrek("Podr",&podr,&naim);
        VV.VVOD_SPISOK_zapis_data(2,podr.ravno());
        goto naz;

      case 1 :
      
        fiov.new_plus("");
        tabn=0;
        if(dirtab(&tabn,&fiov,0,1) == 0)
         {
          tabnom.z_plus(tabn);
          VV.VVOD_SPISOK_zapis_data(3,tabnom.ravno());
         }
        goto naz;

      case 2 :
        vibrek("Plansh",&shet,&naim);
        VV.VVOD_SPISOK_zapis_data(4,shet.ravno());
        goto naz;
      
      case 3 :
        vibrek("Kateg",&kategor,&naim);
        VV.VVOD_SPISOK_zapis_data(5,kategor.ravno());
        goto naz;


     }

  case FK4: /*Очистить меню*/
    VV.VVOD_clear_data();  
    goto naz;

  default:
    goto naz;
 }
GDITE();
short mn,gn;
short mk,gk;

if(rsdat1(&mn,&gn,VV.VVOD_SPISOK_return_data(0)) != 0)
 {
  iceb_t_soob(gettext("Не верно введена дата начала !"));
  goto naz;
 }

if(VV.VVOD_SPISOK_return_data(1)[0] == '\0')
 {
  mk=mn; gk=gn;
 }
else
 if(rsdat1(&mk,&gk,VV.VVOD_SPISOK_return_data(1)) != 0)
  {
   iceb_t_soob(gettext("Не верно введена дата конца !"));
   goto naz;
  }
/************расчёт********************/

int kolstr;
SQL_str row;
SQLCURSOR cur;
masiv_din_int nahis;
masiv_din_int uder;

//формируем масив начислений
sprintf(strsql,"select kod from Nash");

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }
if(kolstr == 0)
 {
  iceb_t_soob(gettext("Не введены начисления !"));
  return(1);
 }
 
while(cur.read_cursor(&row) != 0)
  nahis.plus(atoi(row[0]),-1);

double suma_nahis[nahis.kolih()];
memset(&suma_nahis,'\0',sizeof(suma_nahis));
//формируем масив удержаний
sprintf(strsql,"select kod from Uder");

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  iceb_t_soob(gettext("Не введены удержания !"));
  return(1);
 }

while(cur.read_cursor(&row) != 0)
  uder.plus(atoi(row[0]),-1);

double suma_uder[uder.kolih()];
memset(&suma_uder,'\0',sizeof(suma_uder));


sprintf(strsql,"select tabn,prn,knah,suma,shet,podr,datz from Zarp where \
datz >= '%04d-%02d-%02d' and datz <= '%04d-%02d-%02d' and suma <> 0. \
order by tabn asc",gn,mn,1,gk,mk,31);

if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr == 0)
 {
  iceb_t_soob(gettext("Не найдено ни одной записи !"));
  return(1);
 }

int kolstr1=0;
int prn=0;
double suma=0.;
int knah=0;
int nomer=0;
short dz,mz,gz;
SQL_str row1;
class SQLCURSOR cur1;
while(cur.read_cursor(&row) != 0)
 {

  strzag(LINES-1,0,kolstr,++kolstr1);

  if(proverka(podr.ravno(),row[5],0,0) != 0)
    continue;
  if(proverka(tabnom.ravno(),row[0],0,0) != 0)
    continue;
  if(proverka(shet.ravno(),row[4],0,0) != 0)
    continue;
  if(kategor.ravno()[0] != '\0')
   {
    rsdat(&dz,&mz,&gz,row[6],2);    
    sprintf(strsql,"select kateg from Zarn where tabn=%s and god=%d and mes=%d",row[0],gz,mz);
    if(readkey(strsql,&row1,&cur1) == 1)
     {
      if(proverka(kategor.ravno(),row1[0],0,0) != 0)
       continue;
     }
    else
     {
      printw("%s\n",strsql);
      printw("Не найдена категория для %s\n",row[0]);
      OSTANOV();
     }
   }

  prn=atoi(row[1]);
  knah=atoi(row[2]);
  suma=atof(row[3]);  
  if(prn == 1)//начисления
   {
    if((nomer=nahis.find(knah)) < 0)
     continue;
    suma_nahis[nomer]+=suma;
   }

  if(prn == 2) //удержания
   {
    if((nomer=uder.find(knah)) < 0)
     continue;
    suma_uder[nomer]+=suma;
   }
  
 }

char imaf[64];
FILE *ff;
sprintf(imaf,"snu%d.lst",getpid());
if((ff = fopen(imaf,"w")) == NULL)
 {
  error_op_nfil(imaf,errno,"");
  return(1);
 }

iceb_t_zagolov(gettext("Рacчёт свода начислений и удержаний"),1,mn,gn,31,mk,gk,ff);

if(shet.ravno()[0] != '\0')
 fprintf(ff,"%s:%s\n",gettext("Счёт"),shet.ravno());

if(podr.ravno()[0] != '\0')
 fprintf(ff,"%s:%s\n",gettext("Подразделение"),podr.ravno());

if(tabnom.ravno()[0] != '\0')
 fprintf(ff,"%s:%s\n",gettext("Табельный номер"),tabnom.ravno());
if(kategor.ravno()[0] != '\0')
 fprintf(ff,"%s:%s\n",gettext("Категория"),kategor.ravno());

fprintf(ff,"\n");

snu_ras(1,&nahis,suma_nahis,ff);

fprintf(ff,"\n");

snu_ras(2,&uder,suma_uder,ff);

podpis(ff);

fclose(ff);

oth->spis_imaf.plus(imaf);
oth->spis_naim.plus(gettext("Рacчёт свода начислений и удержаний"));
iceb_t_ustpeh(imaf,1);
return(0);
}
/*******************************/
/*Распечатка*/
/*******************************/

void snu_ras(int metka,//1-Начисления 2-Удержания
masiv_din_int *kod,
double *suma,
FILE *ff)
{
char strsql[512];
class iceb_tu_str naim("");
SQL_str row;
SQLCURSOR cur;

if(metka == 1)
 fprintf(ff,"%s.\n",gettext("Начисления")); 
if(metka == 2)
 fprintf(ff,"%s.\n",gettext("Удержания")); 

fprintf(ff,"\
----------------------------------------------\n");

fprintf(ff,"\
Код|     Наименование             |  Сумма   |\n");

fprintf(ff,"\
----------------------------------------------\n");
double itogo=0.;
for(int i=0; i < kod->kolih() ; i++)
 {
  if(suma[i] == 0.)
   continue;
  if(metka == 1)
   sprintf(strsql,"select naik from Nash where kod=%d",kod->ravno(i));
  if(metka == 2)
   sprintf(strsql,"select naik from Uder where kod=%d",kod->ravno(i));

  if(readkey(strsql,&row,&cur) == 1)
    naim.new_plus(row[0]);
  else
    naim.new_plus("");
    
  fprintf(ff,"%3d %-*.*s %10.2f\n",
  kod->ravno(i),
  iceb_tu_kolbait(30,naim.ravno()),iceb_tu_kolbait(30,naim.ravno()),naim.ravno(),
  suma[i]);
  itogo+=suma[i];
 }
fprintf(ff,"\
----------------------------------------------\n");
fprintf(ff,"%*s:%10.2f\n",iceb_tu_kolbait(34,gettext("Итого")),gettext("Итого"),itogo);

}
