/*$Id: zarrnesvp.c,v 5.6 2013/05/17 14:56:18 sasa Exp $*/
/*20.12.2011	08.04.2011	Белых А.И.	zarrnesvp.c
Чтение процентов для расчёта удержаний с работника
*/
#include "buhg.h"


extern int kodf_esv; /*Код фонда удержания единого социального взноса*/
extern int kodf_esv_bol; /*Код фонда удержания единого социального взноса*/
extern int kodf_esv_bol_inv; /*Код фонда удержания единого социального взноса*/
extern int kodf_esv_inv; /*Код фонда удержания единого социального взноса*/
extern int kodf_esv_dog; /*Код фонда удержания единого социального взноса*/
extern int kodf_esv_vs;

void zarrnesvp(short mr,short gr,class zarrnesvp_rek *all_proc)
{
char strsql[2048];
char bros[2048];
SQL_str row;
class SQLCURSOR cur;

/*читаем процент*/
sprintf(strsql,"select pr1 from Zaresv where kf=%d and datnd <='%04d-%02d-01' order by datnd desc limit 1",kodf_esv,gr,mr);
if(readkey(strsql,&row,&cur) != 1)
 {
  sprintf(bros,"%s-Не найден процент удержания единого социального взноса!\n\%s\n",__FUNCTION__,strsql);
  zar_pr_ins(bros);
 }
else
  all_proc->proc_esv=atof(row[0]);

sprintf(strsql,"select pr1 from Zaresv where kf=%d and datnd <='%04d-%02d-01' order by datnd desc limit 1",kodf_esv_bol,gr,mr);
if(readkey(strsql,&row,&cur) != 1)
 {
  sprintf(bros,"%s-Не найден процент удержания единого социального взноса для больничного!\n\%s\n",__FUNCTION__,strsql);
  zar_pr_ins(bros);
 }
else
   all_proc->proc_esv_bol=atof(row[0]);

sprintf(strsql,"select pr1 from Zaresv where kf=%d and datnd <='%04d-%02d-01' order by datnd desc limit 1",kodf_esv_bol_inv,gr,mr);
if(readkey(strsql,&row,&cur) != 1)
 {
  sprintf(bros,"%s-Не найден процент удержания единого социального взноса c больничного для инвалидов!\n\%s\n",__FUNCTION__,strsql);
  zar_pr_ins(bros);
 }
else
   all_proc->proc_esv_bol_inv=atof(row[0]);


sprintf(strsql,"select pr1 from Zaresv where kf=%d and datnd <='%04d-%02d-01' order by datnd desc limit 1",kodf_esv_inv,gr,mr);
if(readkey(strsql,&row,&cur) != 1)
 {
  sprintf(bros,"%s-Не найден процент удержания единого социального взноса для инвалидов!\n\%s\n",__FUNCTION__,strsql);
  zar_pr_ins(bros);
 }
else
   all_proc->proc_esv_inv=atof(row[0]);

sprintf(strsql,"select pr1 from Zaresv where kf=%d and datnd <='%04d-%02d-01' order by datnd desc limit 1",kodf_esv_dog,gr,mr);
if(readkey(strsql,&row,&cur) != 1)
 {
  sprintf(bros,"%s-Не найден процент удержания единого социального взноса для договоров!\n\%s\n",__FUNCTION__,strsql);
  zar_pr_ins(bros);
 }
else
   all_proc->proc_esv_dog=atof(row[0]);

sprintf(strsql,"select pr1 from Zaresv where kf=%d and datnd <='%04d-%02d-01' order by datnd desc limit 1",kodf_esv_vs,gr,mr);
if(readkey(strsql,&row,&cur) != 1)
 {
  sprintf(bros,"%s-Не найден процент удержания единого социального взноса для военных!\n\%s\n",__FUNCTION__,strsql);
  zar_pr_ins(bros);
 }
else
   all_proc->proc_esv_vs=atof(row[0]);

sprintf(strsql,"%s-Прочитали настройки\n\
Процент удержания единого социального взноса:%.2f\n\
Процент удержания единого социального взноса для больничного:%.2f\n\
Процент удержания единого социального взноса c больничного для инвалидов:%.2f\n\
Процент удержания единого социального взноса для инвалидов:%.2f\n\
Процент удержания единого социального взноса для договоров:%.2f\n\
Процент удержания единого социального взноса для военных:%.2f\n",
  __FUNCTION__,
  all_proc->proc_esv,
  all_proc->proc_esv_bol,
  all_proc->proc_esv_bol_inv,
  all_proc->proc_esv_inv,
  all_proc->proc_esv_dog,
  all_proc->proc_esv_vs);

zar_pr_ins(bros);

}
