/*$Id: zarstfn53.c,v 5.18 2013/08/13 05:50:03 sasa Exp $*/
/*02.10.2014	17.03.2004	Белых А.И.	zarstfn53.c
Шапка типовой формы N53 - платежная ведомость
*/
#include <errno.h>
#include "buhg.h"


int  zarstfn53_0(const char *naipodr,const char *mesqc,short gr,const char *shet,int *kolstr,FILE *ff);
int  zarstfn53_1(const char *naipodr,const char *mesqc,short gr,const char *shet,const char *nomerved,int *kolstr,FILE *ff);


int  zarstfn53(const char *naipodr,short mr,short gr,
const char *shet,
const char *nomerved,
int *kolstr,
FILE *ff)
{
class iceb_tu_str mesqc("");

mesc(mr,0,&mesqc);

if(sravmydat(16,6,2009,30,mr,gr) > 0)
  return(zarstfn53_0(naipodr,mesqc.ravno(),gr,shet,kolstr,ff));
else
  return(zarstfn53_1(naipodr,mesqc.ravno(),gr,shet,nomerved,kolstr,ff));

}
/***************************/
/************************/
int  zarstfn53_0(const char *naipodr,const char *mesqc,short gr,
const char *shet,
int *kolstr,
FILE *ff)
{
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr1=0;
char strsql[512];
class iceb_tu_str stroka("");
class iceb_tu_str kod("");
SQLCURSOR cur;
SQL_str   row;


//читаем код 
sprintf(strsql,"select kod from Kontragent where kodkon='00'");
if(sql_readkey(&bd,strsql,&row,&cur) == 1)
  kod.new_plus(row[0]);



sprintf(strsql,"select str from Alx where fil='zarspv.alx' order by ns asc");
if((kolstr1=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr1 == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"zarspv.alx");
  iceb_t_soob(strsql);
  return(1);
 }


int nomstr=0;
char bros[512];
while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  nomstr++;
  stroka.new_plus(row_alx[0]);
  switch(nomstr)
   {
    case 1:
     //в первых двух символах команды для принтера
     iceb_tu_vstav(&stroka,iceb_t_get_pnk("00",0),3,39,1);
     break;

    case 2:
     iceb_tu_vstav(&stroka,kod.ravno(),32,47,1);
     break;

    case 4:
     iceb_tu_vstav(&stroka,naipodr,0,46,1);
     break;

    case 10:
     sprintf(bros,"%d%s",gr,gettext("г."));
     
     iceb_tu_vstav(&stroka,bros,21,34,1);
     break;

    case 14:
     iceb_tu_vstav(&stroka,shet,42,49,1);
     break;

    case 16:
     sprintf(bros,"%d%s",gr,gettext("г."));
     
     iceb_tu_vstav(&stroka,bros,14,22,1);
     break;

    case 18:
     sprintf(bros,"%s %d%s",mesqc,gr,gettext("г."));
     
     iceb_tu_vstav(&stroka,bros,28,50,1);
     break;
        
   }
  *kolstr+=1;     
  fprintf(ff,"%s",stroka.ravno());
  
 }
 
return(0);

}
/*************************************/
/**************************************/
int  zarstfn53_1(const char *naipodr,const char *mesqc,short gr,
const char *shet,
const char *nomerved,
int *kolstr,
FILE *ff)
{
SQL_str row_alx;
class SQLCURSOR cur_alx;
int kolstr1=0;
char strsql[512];
class iceb_tu_str stroka("");
class iceb_tu_str kod("");
SQLCURSOR cur;
SQL_str   row;


//читаем код 
sprintf(strsql,"select kod from Kontragent where kodkon='00'");
if(sql_readkey(&bd,strsql,&row,&cur) == 1)
  kod.new_plus(row[0]);



sprintf(strsql,"select str from Alx where fil='zarspv2.alx' order by ns asc");
if((kolstr1=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(1);
 }

if(kolstr1 == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"zarspv2.alx");
  iceb_t_soob(strsql);
  return(1);
 }

int nomstr=0;
char bros[512];
while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
   continue;
  nomstr++;
  stroka.new_plus(row_alx[0]);
  switch(nomstr)
   {
    case 1:
     //в первых двух символах команды для принтера
     iceb_tu_vstav(&stroka,iceb_t_get_pnk("00",0),3,39,1);
     break;

    case 2:
     iceb_tu_vstav(&stroka,kod.ravno(),32,47,1);
     break;

    case 4:
     iceb_tu_vstav(&stroka,naipodr,0,46,1);
     break;

    case 10:
     sprintf(bros,"%d%s",gr,gettext("г."));
     
     iceb_tu_vstav(&stroka,bros,21,34,1);
     break;

    case 14:
     iceb_tu_vstav(&stroka,shet,42,49,1);
     break;

    case 17:
     sprintf(bros,"%d%s",gr,gettext("г."));
     
     iceb_tu_vstav(&stroka,bros,14,22,1);
     break;

    case 19:
     iceb_tu_vstav(&stroka,nomerved,43,52,1);
     break;

    case 20:
     sprintf(bros,"%s %d%s",mesqc,gr,gettext("г."));
     
     iceb_tu_vstav(&stroka,bros,28,50,1);
     break;
        
   }
  *kolstr+=1;     
  fprintf(ff,"%s",stroka.ravno());
  
 }
 
return(0);

}
