/*$Id:$*/
/*05.04.2016	18.12.2014	Белых А.И.	iceb_t_getkoddok.c
получить код налоговой накладной в формате xml
*/
#include "buhl.h"

const char *iceb_t_getkoddok(short d,short m,short g,
int metka) /*1-код налоговой накладной 
             2-реестр налоговых накладных
             3-Расчёт корректировки сумм НДС к налоговой декларации с налога на добавленную стоимость-додаток 1
             4-додаток 5
             5-додаток 2
             6-форма 1 дф
            */
{
static char kod_nn[64];

memset(kod_nn,'\0',sizeof(kod_nn));
switch(metka)
 {
  case 1: /*Налоговая накладная*/
/*********************
   if(sravmydat(d,m,g,1,12,2014) < 0)
    strcpy(kod_nn,"J1201005");

   if(sravmydat(d,m,g,1,12,2014) >= 0 && sravmydat(d,m,g,1,1,2015) < 0)
    strcpy(kod_nn,"J1201006");

   if(sravmydat(d,m,g,1,1,2015) >= 0  && sravmydat(d,m,g,1,4,2016) < 0)
    strcpy(kod_nn,"J1201007");

   if(sravmydat(d,m,g,1,4,2016) >= 0)
*******************/
    strcpy(kod_nn,"J1201008");

   break;

  case 2: /*Реестр налоговых накладных*/
   
   if(sravmydat(d,m,g,1,3,2013) < 0)
    strcpy(kod_nn,"J1201505");
   
   if(sravmydat(d,m,g,1,3,2013) >= 0 && sravmydat(d,m,g,1,1,2014) < 0)
    strcpy(kod_nn,"J1201506");
   
   if(sravmydat(d,m,g,1,1,2014) >= 0 && sravmydat(d,m,g,1,12,2014) < 0)
    strcpy(kod_nn,"J1201507");

   if(sravmydat(d,m,g,1,12,2014) >= 0)
    strcpy(kod_nn,"J1201508");

   break;

  case 3:   /*Расчёт корректировки сумм НДС к налоговой декларации с налога на добавленную стоимость-додаток 1*/

   if(sravmydat(d,m,g,1,12,2014) < 0)
    strcpy(kod_nn,"J0200512");
   if(sravmydat(d,m,g,1,12,2014) >= 0 && sravmydat(d,m,g,1,1,2016) < 0)
    strcpy(kod_nn,"J0200513");
   if(sravmydat(d,m,g,1,1,2016) >= 0) /*14 пропустил*/
    strcpy(kod_nn,"J0200515");
      
   break;

  case 4:   /*Додаток 5  до податкової декларації з податку на додану вартість*/

   if(sravmydat(d,m,g,1,12,2014) < 0)
    strcpy(kod_nn,"J0215105");

   if(sravmydat(d,m,g,1,12,2014) >= 0 && sravmydat(d,m,g,1,2,2015) < 0 )
    strcpy(kod_nn,"J0215106");

   if(sravmydat(d,m,g,1,2,2015) >= 0 && sravmydat(d,m,g,1,1,2016) < 0)
    strcpy(kod_nn,"J0215107");

   if(sravmydat(d,m,g,1,1,2016) >= 0)
    strcpy(kod_nn,"J0215108");


   break;

  case 5:   /*Додаток 2*/
    strcpy(kod_nn,"J0285106");
   break;

  case 6:   /*Форма 1дф*/
   if(sravmydat(d,m,g,1,1,2015) < 0)
    strcpy(kod_nn,"J0500104");
   else
    strcpy(kod_nn,"J0500105");
    break;

             
  default:
   char stroka[1024];
   sprintf(stroka,"%s-%s %d!",__FUNCTION__,gettext("Не известный код документа"),metka);
   iceb_t_soob(stroka);
  
   break;
 }
 
return(kod_nn);


}

