/*$Id: iceb_t_ko1.c,v 5.10 2013/05/17 14:56:28 sasa Exp $*/
/*30.09.2014	09.01.2008	Белых А.И.	iceb_t_ko1.c
Распечатка приходного кассового ордера на бланке строгой отчётности
*/


#include        <errno.h>
#include	"buhl.h"


void iceb_t_ko1(const char *imaf,
const char *nomd,
short dd,short md,short gd,
const char *shet,
const char *shetkas,
double suma,const char *fio,const char *osnov,const char *dopol,FILE *ff_f)
{
SQL_str		row;
SQLCURSOR       cur;
char		strsql[512];
class iceb_tu_str naim("");
char		kodedrp[32];
char		sumac[200];
FILE		*ff=ff_f;


memset(kodedrp,'\0',sizeof(kodedrp));
memset(sumac,'\0',sizeof(sumac));

preobr(suma,sumac,0);
sprintf(strsql," (%.2f)",suma);
strcat(sumac,strsql);
/*Читаем реквизиты организации*/

sprintf(strsql,"select naikon,kod from Kontragent where kodkon='00'");

if(sql_readkey(&bd,strsql,&row,&cur) == 1)
 {
  naim.new_plus(row[0]);
  strncpy(kodedrp,row[1],sizeof(kodedrp)-1);
 }

if(imaf[0] != '\0')
 {
  if((ff = fopen(imaf,"w")) == NULL)
    {
     error_op_nfil(imaf,errno,"");
     return;
    }
  startfil(ff);
 }

fprintf(ff,"\x1b\x6C%c",7); /*Установка левого поля*/
fprintf(ff,"\x1B\x4D"); /*12-знаков*/
fprintf(ff,"\x0F");  /*Ужатый режим*/
fprintf(ff,"\x1B\x33%c\n",30); /*Уменьшаем межстрочный интервал*/


fprintf(ff,"%-*.*s %46s %.*s\n",
iceb_tu_kolbait(50,naim.ravno()),
iceb_tu_kolbait(50,naim.ravno()),
naim.ravno(),"",
iceb_tu_kolbait(50,naim.ravno()),
naim.ravno());


fprintf(ff,"\n%s\n",kodedrp);

fprintf(ff,"\n");

fprintf(ff,"%100s %s:%s\n","","Номер документу",nomd); 

for(int i=0; i < 3; i++)
 fprintf(ff,"\n");


fprintf(ff,"%100s %14s %-*.*s\n\n","","",
iceb_tu_kolbait(30,fio),
iceb_tu_kolbait(30,fio),
fio); 

if(iceb_tu_strlen(fio) > 30)
 fprintf(ff,"%100s %-*.*s\n","",
 iceb_tu_kolbait(40,iceb_tu_adrsimv(30,fio)),
 iceb_tu_kolbait(40,iceb_tu_adrsimv(30,fio)),
 iceb_tu_adrsimv(30,fio));
else
 fprintf(ff,"\n");

fprintf(ff,"\n");
fprintf(ff,"\n");

fprintf(ff,"%100s %10s %-*.*s\n\n","","",
iceb_tu_kolbait(34,osnov),
iceb_tu_kolbait(34,osnov),
osnov);
  
fprintf(ff,"%-9s %02d.%02d.%04d        %-10s  %-10s %-20.2f",
nomd,dd,md,gd,shet,shetkas,suma);

if(iceb_tu_strlen(osnov) > 38)
 fprintf(ff,"%28s %.*s","",
 iceb_tu_kolbait(40,iceb_tu_adrsimv(38,osnov)),
 iceb_tu_adrsimv(38,osnov));
 
fprintf(ff,"\n\n\n");

fprintf(ff,"%15s %.*s\n","",
iceb_tu_kolbait(80,fio),
fio);

fprintf(ff,"%100s %.40s\n","",sumac);

if(iceb_tu_strlen(sumac) > 40)
  fprintf(ff,"%100s %.*s\n","",
  iceb_tu_kolbait(40,iceb_tu_adrsimv(40,sumac)),
  iceb_tu_adrsimv(40,sumac));
else
  fprintf(ff,"\n");

class iceb_tu_str mesqc("");
mesc(md,1,&mesqc);
   
fprintf(ff,"%10s %-80.80s\n","",osnov);

if(iceb_tu_strlen(osnov) > 80)
 fprintf(ff,"%-*.*s %20s %02d %s %02d р.\n",
 iceb_tu_kolbait(80,iceb_tu_adrsimv(80,osnov)),
 iceb_tu_kolbait(80,iceb_tu_adrsimv(80,osnov)),
 iceb_tu_adrsimv(80,osnov),
 "",dd,mesqc.ravno(),gd);
else 
 fprintf(ff,"%100s  %02d %s %02d р.\n","",dd,mesqc.ravno(),gd);
   
fprintf(ff,"\n\n\n%s\n\n",sumac);

fprintf(ff,"%10s %.*s\n","",
iceb_tu_kolbait(80,dopol),
dopol);

if(iceb_tu_strlen(dopol) > 80)
 fprintf(ff,"%.*s\n",
 iceb_tu_kolbait(80,iceb_tu_adrsimv(80,dopol)),
 iceb_tu_adrsimv(80,dopol));
else 
 fprintf(ff,"\n");


if(imaf[0] != '\0') 
 {
  fclose(ff);
 }
}
